require({cache:{
'url:dojoe/tablex/templates/Table.html':"\r\n<div class=\"tivTable\" tabIndex=0 aria-label=\"table\" role=\"application\">\r\n\t<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\" height=\"100%\" \r\n\t\tstyle=\"width:100%;height:100%;\" role=\"presentation\">\t\t\r\n\t\t<tr valign=\"center\">\r\n\t\t\t<td width=\"100%\" role=\"toolbar\">\r\n\t\t\t\t<div dojoAttachPoint=\"wipeNode\">\r\n\t\t\t\t<div dojoAttachPoint=\"toolbarNode\"></div>\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr valign=\"center\"><td width=\"100%\" role=\"grid\">\r\n\t\t\t<div  dojoAttachPoint=\"enhancedGridNode\"></div></td></tr>\t\t\r\n\t</table>\r\n</div>\t"}});
define("dojoe/tablex/Table", [
	"dojo/_base/declare",
	"dojo/_base/array",
    "dijit/_WidgetBase",
    "dijit/_TemplatedMixin",
    "dojo/text!./templates/Table.html",
    "gridx/Grid",
    "dojo/_base/lang",
	"dojo/dom-geometry",
	"dojo/window",
	"dojo/dom-style",
	"dojox/collections/ArrayList",
    "dojoe/tablex/_Toolbar",
    "dojo/i18n",
    "dojoe/slidingpane/SlidingPane",
    "dojo/i18n!dojoe/tablex/nls/Table",
	"gridx/core/model/cache/Sync",
	"gridx/core/model/cache/Async",
	"dojoe/tablex/plugins/_MapToModules",
	"gridx/modules/Persist"
		
        ], function(Declare, Array, _Widget, _TemplatedMixin, Template, Grid, Lang, DomGeometry,
        			Window, DomStyle, ArrayList, _Toolbar, Il8n, SlidingPane, NLS, Cache, ServerCache, _MapToModules, Persist ){
		
			var forEach = Array.forEach;
	
			Table = Declare('dojoe.tablex.Table', [_Widget, _TemplatedMixin], {
				// summary:  
				// 		Table widget is used to display potentially large, multivariate, structured data sets.
				//
				// description: 
				//	Table widget implementation is based on gridx
				//	Provides additional features upon gridx like toolbar with state control buttons (refresh)
				//	custom actions drop down and Filter(search) controls.
				//	Usage
				//	example:
				//		Usage example 1: Using Plugins (compatible way)
				//
				//		Main advantage of this format is to be able to use plugins as it is with the old EDG based table
				//		Differences from the EDG based Table configuration in comatibility mode: 
				//		layout: new gridx "structure" expects the layout info in different format (formatters are now called decorators, no hidden parameter support and editor support)
				//		Please refer to gridx documentation for layout information
				//		Please note that "gridParams_" holds gridx parameters and hence subject to change when dojo api/attributes changes
				//
				// |		var table = new Table({
				// |											  gridParams_ : {
				// |															rowsPerPage : 5,
				// |															store : jsonStore1,
				// |															structure : layout,
				// |															plugins :{
				// |																	  indirectSelection : true,
				// | 																	  nestedSorting : true,
				// |																	  dnd : true
				// |																     }
				// |															},
				// |															toolbarOptions : {},
				// |															enableResize : true
				// |											  }, domNode);	
				//	
				//		example:
				//		Usage example 2: Using Modules (new Gridx modules)
				// |		var grid = new Grid({
		        // |						cacheClass: Cache,
		        // |						store: store,
		        // |            			structure: columns,
		        // |            			modules: [
		        // |					   	 		Sort,       //Declare modules in a grid instance
		        // |					   	 		ColumnResizer,   //Declare modules in a grid instance
				// |								IndirectSelect,
				// |								NestedSort
		        // |						]
				// |					});
										
				// templateString:  String
				// Path to the template
				templateString : Template,
			
				// widgetsInTemplate: Boolean
				//		Set this to true if the widget contains other widgets
				widgetsInTemplate : true, 
				
				// toolbarVisible: Boolean
				//		Controls the visibility of the toolbar.
				toolbarVisible : true, 
				
				// toolbarOptions:  Object
				//		Holds the  information about the toolbar options passed by the user.
				toolbarOptions : null, 
				
				// filterOptions:  Object
				//		Holds all the filter information passed by the user.
				filterOptions : {}, 
				
				// enableResize: Boolean
				//		Controls the grid resize  on window resize event. 
				//		If true enables the table resize when the window resizes ,if false disable table resize on window resize event.
				enableResize : false,
				
				// gridParams:  Object
				//		Holds  parameters passed to grid by the user. These are dojo gridx parameters and subject to change when dojo api/attributes changes.	
				gridParams_ : null, 
				
				// grid: Object
				//		 gridx/Grid handle. Avoid using the underlying grid directly.
				// tags: private
				_grid : null, 
				
				//Enabled by default, set false to disable the default exportFormatter and set yours
				defaultExportFormatter : true, 
				
				// pageSizeArr:  array
				//		An array holds the size of the page.
				pageSizeArr : null, 
				
				// width: number  
				//		Holds the width of the grid set by user.  It can be set in px,percentage or em like '50px','50%' or '50em'.
				width : '', 
				
				// height: number
				//		Holds the height of the grid set by user. It can be set in px,percentage or em like '150px','150%' or '150em'.
				height : '', 
				
				// _toolbar: Object
				//		Reference to the toolbar
				// tags: private
				_toolbar : null, 
				
				// _defaultHeight:  number
				//		Holds the default height of the grid. 
				// tags: private	
				_defaultHeight : '70%', 
				
				// _defaultWidth: number
				//		Holds the default width of the grid
				// tags: private	
				_defaultWidth : '80%', 
				
				// footerdescription: boolean
				//		Description of the grid footer 
				footerDescription: true,
				
				// footerVisible: boolean
				//		Holds the visibility status of the footer
				footerVisible:true,
				
				// resources_:  Object
				//		Reference to the resources
				// tags: private
				resources_ : null, 
				
				// _previousSize: Object
				// Reference value for resize
				// tags: private
				_previousSize : null,
				
				// _resizing: boolean
				// flag to indicate resize is in progress
				// tags: private
				_resizing : false,
				
				// enableCollapsibleToolbar: boolean
				//To add collapsible toolbar  to the table
				enableCollapsibleToolbar : false,
				
				// toolbarExpand: boolean
				//To indicate(preset) the state of the toolbar on load
				toolbarExpand : true,
				
				// _originalStructure: original Structure set to the table
				// tags: private
				_origLayout : null,
				
				// _currentLayout: layout object after filtering columns with hidden parameters
				// tags: private
				_currentLayout : null,
				
				// persistOptions: Boolean - if enabled persists config options settings and column properties
				persistOptions : false,
				
				
				constructor : function () {
					this.resources_ = NLS;
					this.pageSizeArr = ["5", "10", "25", "50", "100", "All"];
				}, 
				
				postCreate : function () {
					// summary:  Creates and initializes the table.
					// tags: extension
					
					if (this.width === '' && !this.gridParams_.autoWidth) {
						this.width = this._defaultWidth;
					}
					if (this.height === '' && !this.gridParams_.autoHeight) {
						this.height = this._defaultHeight;
					}
					
					var size = Window.getBox();
					var heightPx = this.height;
					var sizeType = this.height.substring(this.height.length - 1, this.height.length);
					if (sizeType == "%") {
						//convert to px
						heightPx = size.h * ((parseInt(this.height.slice(0, -1))) / 100);
						heightPx = heightPx + "px";
					}
					if (!this.gridParams_.autoWidth) {
						DomStyle.set(this.domNode, {width: this.width});
					}
					DomStyle.set(this.domNode, "height", heightPx);
					
					this._makeGrid();
					if (this.toolbarVisible) {
						this._toolbar = new _Toolbar({
								tivTable : this
							}, this.toolbarNode);
							
						if (this.enableCollapsibleToolbar) {
							this.slidingPane = new SlidingPane({closeNodeClass: "slidingPaneClose", open: this.toolbarExpand}, this.wipeNode);
							this.connect(this.slidingPane, "onClick", Lang.hitch(this, "slidingPaneClicked"));//Connecting event onClick to sliding pane.
						}
					
					} else {
						if(this.filterOptions.hideFilterBar == true && this._grid.filterBar !== undefined){
							this._grid.filterBar.hide();
						} 
					} 
					if(this._grid.filterBar){
						// hack until dojo team fixes the issue on gridx or provides a new flag to disable autocomplete
						this._grid.filterBar.autoComplete = false;
					}
					this.resize();
					if (this.enableResize === true) {
						this.connect(window, "onresize", "resize");
					}
					if(this._toolbar && this._toolbar.actionListWidget){	
						this.connect(this._toolbar.actionListWidget, 'openDropDown', Lang.hitch(this,"onActionListOpen")); 
						this.connect(this._toolbar.actionListWidget, 'closeDropDown', Lang.hitch(this,"onActionListClose")); 			
					}
					
					setTimeout(Lang.hitch(this, "onTableLoad", this), 1000);
					
				}, 
				//Connect to this to monitor Table load complete.
				onTableLoad : function (table) {
					// summary: 
					//		Called after the Table loads
					// tags:
		   		    //      callback
					console.info("Table load complete....." + table.id);
				}, 
				
				//Connect to this to monitor Opening of actionList
				onActionListOpen : function(){
					// summary: 
					//		Called onClick of "Actions" Drop down menu
					// tags:
		   		    //      callback

					//console.info("actionListOpen.....");
				},
				
				//Connect to this to monitor Closing of actionList
				onActionListClose : function(){
					// summary: 
					//		Called onClose of "Actions" Drop down menu
					// tags:
		   		    //      callback
		   		    
					//console.info("actionListClosed.....");
				},		
				
				_makeGrid : function () {
					// summary:  Creates grid with the specified plugins and parameters.
					// tags: private	
					
					this._mapgridParams(); // this function is used to map ted plugins params with EnhancedGrid plugin params which may change frequently.
					
					this._mapToModules();
					if(!this.gridParams_.cacheClass){
						this.gridParams_.cacheClass = ServerCache;
					}
					//setting the Printer plugin when the Exporter plugin is set to make the Export to HTML work with css
					if (this.gridParams_.plugins && this.gridParams_.plugins.exporter === true && !this.gridParams_.plugins.printer) {
						var tempParams = this.gridParams_;
						tempParams.plugins.printer = true;
						this._grid = new grid(tempParams, this.enhancedGridNode);
						delete tempParams.plugins.printer;
					} else {
						this._grid = new Grid(this.gridParams_, this.enhancedGridNode);
					}
					//startup and resize has problems when grid is added to a custom widget _widget
					//so set appropriate height and width to grid domNode, update and parse the domNode after resize
					if (this.gridParams_.preFilter) {				
						this.setFilter(this.gridParams_.preFilter, this.gridParams_.preFilter.hideFilterBar);
					}
					//to display the default message when grid is empty or filter result is none
					if (!this.gridParams_.noDataMessage) {
						this._grid.noDataMessage = this.resources_.NO_DATA;
					} else {
						this._grid.noDataMessage = this.gridParams_.noDataMessage;
					}					
						
					this._grid.startup();
					// use onModulesLoaded callback to ensure the Persist module is loaded before operating on the columns
					this.connect(this._grid,"onModulesLoaded", Lang.hitch(this,"_persistColumns"));
					
					if(this.gridParams_.plugins && this.gridParams_.plugins.menus){
						var menus = this.gridParams_.plugins.menus;
						if(menus.headerMenu){
							var menuArgs = {hookPoint: "headercell"};
							this._bindMenu(menus.headerMenu,menuArgs );
						}
						if(menus.rowMenu){
							var menuArgs = {hookPoint: "row"};
							this._bindMenu(menus.rowMenu,menuArgs );
						}
						if(menus.selectedRegionMenu){
							var menuArgs = {hookPoint: "row", selected: true};
							this._bindMenu(menus.selectedRegionMenu,menuArgs );
						}
						
					}
					//not needed as there is a direct mapping available with gridx module
					/*if(this.gridParams_.plugins && this.gridParams_.plugins.pagination ){
						if(this.gridParams_.plugins.pagination.defaultPageSize && this._grid.pagination){
								this._grid.pagination.setPageSize(this.gridParams_.plugins.pagination.defaultPageSize );
						}
					}*/
					if(this.gridParams_.plugins && this.gridParams_.plugins.filter ){
						/*if(this.gridParams_.plugins.pagination.defaultPageSize && this._grid.pagination){
								this._grid.pagination.setPageSize(this.gridParams_.plugins.pagination.defaultPageSize );
						}*/
					}
				}, 
				_persistColumns : function () {
					// summary:   
					//	If persistOptions is enabled this is invoked to persist the column information in a cookie..	
					// tags: private
					// set filtered structure in case hidden parameters are present
					//LS - 10/6/12 - 54009: Need persistence support in gridx tables
					if( this.persistOptions && this._grid.persist ){
						// if hidden columns are configured using config columns dialog use the data from cookie
						var content = this._grid.persist.get(this._grid.id);
						if(content && content["configColumns"]){
							var visibleColsConfig = content["configColumns"];
							var col, cols =[], grid = this._grid;
							var structure = this._origLayout;
							if(Lang.isArray(visibleColsConfig.visibleCols)){
								Array.forEach(visibleColsConfig.visibleCols, function(col){
									Array.some(structure, function(c){
										if(c.field == col.field){
											cols.push(c);
											return true;
										}
										
									});
								});
								this._grid.setColumns(cols);
							}
							this._grid.body.refresh();
						}else{
							//LS - 10/11/2012 - 54009 - Persisted width and sort props are overwritten
							// in case persistOptions is not used and user is using gridx Persist directly... need to set back the persisted col info 
							// as the original structure while constructing the grid
							if(this._grid.persist){
								this._origLayout =  this._grid._columns;
							}
							this._filterHiddenColumns(this._origLayout);
						}
						
					}else{
						if(this._grid.persist){
							this._origLayout =  this._grid._columns;
						}
						this._filterHiddenColumns(this._origLayout);
					}
				},
				
				_mapgridParams : function () {
					// summary:   
					//		Maps ted plugins params with EnhancedGrid plugin params which may change frequently.
					// tags: private
					
					/* Parameters that could be defined for gridParams_.plugins
						filter:true, for grid filter
						dnd:true, for drag and drop - cell,row and column
						nestedSorting:true, for nested sorting feature
						indirectSelection:true, for checkboxes column
						menus:{headerMenu:"headerMenu", rowMenu:"rowMenu",  selectedRegionMenu:"selectedRegionMenu"}, for cell,row,header and selected region menu
						printer:true, for print feature
						exporter:true, for export data feature
						sortfields:[{ attribute:field name,ascending/descending:boolean...}]
						For pagination, by default pagination will be enabled, if it needs to be disabled please set "pagination:false" on this widget
						
						selector: true by default, set false to disable selector plugin.. else default selector config will be applied
						enableResize : true, to enable the table resize when the window resizes
						enableResize : false, to disable table resize on window resize event.
						To resize the table on a particular event, connect the event to table's resize() function
					*/
					
					if (this.gridParams_.plugins && this.gridParams_.plugins.pagination) {
						/*#37646: LS : Table: Rows per page property is not working
						 * there is a new attribute in Pagination plugin "defaultPagesize" which takes precedence over rowsPerPage
						 * value if Pagination is enabled
						 * mapping rowsPerPage value to defaultPagesize attribute only if the rowsPerPage setting is present in the PagesSizes array
						 * if not present first entry of the PageSizes array will be the default rowsPerPage..
						 * if user specifies for example: pagination:{defaultPageSize:10} this will take precedence over the rowsPerPage value*/
						
						var pagination = null;
						var defaultPageSize = (this.gridParams_.plugins.pagination.defaultPageSize > 0)?
								this.gridParams_.plugins.pagination.defaultPageSize : this.pageSizeArr[0];
						if(this.gridParams_.rowsPerPage > 0 && !this.gridParams_.plugins.pagination.defaultPageSize){
							for(var i=0; i < this.pageSizeArr.length; i++){
								if(this.pageSizeArr[i] == this.gridParams_.rowsPerPage){
									defaultPageSize = this.gridParams_.rowsPerPage;
									break;
								}
							}
						}
						pagination = {
							pageSizes : this.pageSizeArr, // Array, custom the items per page button
							// itemTitle: "entrys", 	// String, custom the item title of description
							description : this.footerDescription, // boolean, custom whether or not the description will be displayed
							sizeSwitch : true, // boolean, custom whether or not the page size switch will be displayed
							pageStepper : true, // boolean, custom whether or not the page step will be displayed
							gotoButton : true, 
							maxPageStep : 10, // Integer, custom how many page step will be displayed
							position : "bottom",// String, custom the position of the paginator bar
							defaultPageSize : defaultPageSize
							// there're three options: top, bottom, both
						};
						this.gridParams_.plugins.pagination = pagination;
					} else {
						if(this.footerVisible && this.gridParams_.plugins){ // checking if the footer need to be displayed
							pagination = {
								//changes to use SummaryBar instead of Pagination with just description
								// need to get support for description template for summary bar (to do)	
								descTemplate : "${1} ${0}",// A template of the current position description.
								onlyDesc : true // new attribute to identify pagination should not be loaded and just the pagination bar with desc should be displayed
							};
							this.gridParams_.plugins.pagination = pagination;
						}
						
					}
					
					if (this.gridParams_.plugins && this.gridParams_.plugins.indirectSelection ) {
						//always display the "select all" check box by default
						if (this.gridParams_.plugins.indirectSelection instanceof Object && this.gridParams_.plugins.indirectSelection.headerSelector == undefined){ 
							dojo.mixin(this.gridParams_.plugins.indirectSelection, {
								"headerSelector" : true
							});
						}else{
							this.gridParams_.plugins.indirectSelection = {"headerSelector" : true};
						}
						if(this.gridParams_.selectionMode && this.gridParams_.selectionMode == "single"){
							dojo.mixin(this.gridParams_.plugins.indirectSelection, {
								"multiple" : false
							});
						}
					}
					
					if (this.gridParams_.plugins && this.gridParams_.plugins.filter !== undefined) {
						//always display the closeFilterBarButton
						this.gridParams_.plugins.filter.closeFilterbarButton = true;
						//hide the filter bar by default
						if (this.gridParams_.preFilter ) {
							this.filterOptions.hideFilterBar = false;
						} else {
							this.filterOptions.hideFilterBar = true;
						}				
						if (this.gridParams_.plugins.filter.advancedFilter !== undefined) {
							this.filterOptions.advancedFilter = this.gridParams_.plugins.filter.advancedFilter;
							delete this.gridParams_.plugins.filter.advancedFilter;
						}
						if (this.gridParams_.plugins.filter.quickFilter !== undefined) {
							this.filterOptions.quickFilter = this.gridParams_.plugins.filter.quickFilter;
							delete this.gridParams_.plugins.filter.quickFilter;
						}
						if (this.gridParams_.plugins.filter.showQuickFilterButton !== undefined) {
							this.filterOptions.quickFilterButton = this.gridParams_.plugins.filter.showQuickFilterButton;
							delete this.gridParams_.plugins.filter.showQuickFilterButton;
						}	
						if (this.gridParams_.plugins.filter.searchDelay !== undefined) {
							this.filterOptions.searchDelay = this.gridParams_.plugins.filter.searchDelay;
						}	
						if (this.gridParams_.plugins.filter.retainSelection !== undefined) {
							this.filterOptions.retainSelection = this.gridParams_.plugins.filter.retainSelection;
						}					
								
					}
					//set original column structure to keep a reference of overall structure including hidden columns
					if(this.gridParams_.structure && !this._origLayout){
						this._origLayout = this.gridParams_.structure;
								
					}
										
				}, 
				
				_mapToModules : function() {
					// summary:   
					//		Maps plugins params to modules of gridx to be backward compatible
					// tags: private
					var userModules = (this.gridParams_.modules) || [];
					if(this.gridParams_.plugins){
						this.gridParams_.modules = userModules.concat(_MapToModules.convertToModules(this.gridParams_.plugins));
					}else{
						this.gridParams_.modules = (_MapToModules._getCoreModules()).concat(userModules);
					}

					if(this.persistOptions){
						//load persist module...conditionally
						this.gridParams_.modules.push(Persist);
					}
				},
				
				resize : function (/*event*/event) {
					// summary:  
					//		Resizes the table
					// description:
					//		Resizes the table with given width and height. Also takes care of window resize events.
					//		Connect to this function to resize table on change/resize of layout/container	 
					// tags:  public
					
					var resizeEvent = false;
					if(event && event.currentTarget){
						resizeEvent = true;
					}
					
					var size = Window.getBox();
					if(this._previousSize && this._previousSize.h == size.h && this._previousSize.w == size.w && resizeEvent == true){
						return;				
					}else{
						this._previousSize =  size;
					}			
					
					//if we have set up everything except the DOM, we cannot resize
					//if (!this.domNode.parentNode || this.domNode.parentNode.nodeType != 1) {
					if (!this._grid || !this.domNode || !this.domNode.parentNode || this.domNode.parentNode.nodeType != 1) {
						return;
					}
					/*supporting autoWidth feature of grid*/
					if (!this._grid.autoWidth) {
						DomStyle.set(this.domNode, "width", this.width);				
					} else {
						DomStyle.set(this.domNode, "width", DomGeometry.getMarginBox(this._grid.domNode).w + 'px');
					}
					
					var heightPx = this.height;
					if (!(this.domNode.parentNode.style && this.domNode.parentNode.style.height)) {
						var sizeType = this.height.substring(this.height.length - 1, this.height.length);
						//if the height is given in % then translate it to pixel
						if (sizeType == "%") {
							//convert to px
							heightPx = size.h * ((parseInt(this.height.slice(0, -1))) / 100);
							heightPx = heightPx + "px";
						}
					}
					
					DomStyle.set(this.domNode, "height", heightPx);
					setTimeout(Lang.hitch(this, function(){this._delayResize(resizeEvent);}), 100);
				}, 
				
				_delayResize: function (resizeEvent) {
					// summary:  
					//		invoked with delay for grid resize
					// tags:
					//		 private
								
					/*using marginBox to include margins/borders of the domNode*/					
					// 53485:  KDM 10/12/12:   Sizing issue in IE8(nodeType null error)
					if(this.domNode){
						var tableSize = DomGeometry.getMarginBox(this.domNode);
						if(tableSize){
							if (this._toolbar) {
								/*calculating toolbarsize including margins and borders as they contibute to some height*/
								var toolbarSize = DomGeometry.getMarginBox(this._toolbar.domNode);
								//removing grid padding height which will be later added when pagination bar is placed and grid view node is resized.
								tableSize.h = tableSize.h - toolbarSize.h ;				
							}
							/*Resize issue with tables in multiple tabs, 
								Table should not attempt to resize when hidden */
							if((tableSize.h <= 0 || tableSize.w <= 0 )){
								return;
							}

							if(resizeEvent){
								this._grid.resize({
									h : tableSize.h,
									w : tableSize.w
								});
							}else{
								//This check has been added for rendering issue of table inside wizard.In IE7 resize is happening only on passing both height and width. 
								// 53485: KDM 10/12/12:  Vertical scrollbar error in IE8 when no content (Dojo defect, but try/catch put in place for 1.0.2)
								if(dojo.isIE == 7) {
									try {
										this._grid.resize({
											h : tableSize.h,
											w : tableSize.w
										});
									}catch(ex){
										// Catch Dojo bug with VScroller in IE7 until Dojo can be fixed									
									}
								} else { 
									this._grid.resize({
										h : tableSize.h,
										w : tableSize.w //189737: also resize the width of the gridx if it's not resize event
									});
								}
							}
							var heightPx = this.height;
							if(this.enableCollapsibleToolbar) {
								if(this.slidingPane!=null && !this.slidingPane.open) {
									tableSize.h = parseInt(heightPx) - 8;
									this._grid.resize({
										h : tableSize.h
									});
								}
							}
						}	
					}
					this._resizing = false;  		
				},
				
				getRowCount : function () {
					// summary:   
					//		Returns the total number of rows present in the grid.
					// tags:  public	
					// returns: total number of rows.
					
					return this._grid.rowCount();
				}, 
				
				getSelectedRowCount : function () {
					// summary:   
					//		Returns the number of selected rows in the grid.
					// tags: public	
					// returns: total number of selected rows.
					
					return this._grid.select.row.getSelected().length;
				}, 
				
				getSelectedRows : function () {
					// summary:   
					// 		Returns the selected rows from the grid.
					// tags: public
					// returns: selected rows.
					
					return this._grid.select.row.getSelected();
				}, 
				
				getFilter : function () {
					// summary:
					//		Returns filter data in json format if fiterBar is enabled
					// tags: private
					// returns: filter data object
					return this._getFilterData();
				}, 
				
				_getFilterFunc : function (){
					// summary:
					//		Returns current Checker function from Filter module. Please refer gridx Filter module
					// tags: private
					// returns:Function|null|undefined (or anything that is invalid)
					if(this._grid.filter){
						return this._grid.filter.getFilter();
					}
					return null;
				},
				
				_getFilterData : function (){
					// summary:
					//		Returns filter data in json format if fiterBar is enabled
					// tags: private
					// returns: filter data object
					if(this._grid.filterBar){
						return this._grid.filterBar.filterData;
					}
					return null;
				},
				
				getFilterRelation : function () {
					// summary:  
					// 		Returns  the relationship between filter rules specified.
					// tags: public
					// returns:
					//		Filter Rule Relations
					if (this._grid.filterBar) {
						return this._grid.filterBar.filterData.type;
					}
				}, 
				
				_getColumnName : function (index) {
					// summary:  
					//		Returns the column name for the specified column index
					// tags: private
					// index: number
					// returns:  	
					//		Name of the column
					
					return this._grid.column(index);
				}, 
				
				_getColumnField : function (index) {
					// summary:  
					//		Returns the column field for the specified column index
					// tags: private
					// index: number
					// returns: 
					//		Field of the column
					return (this._grid.column(index)).field();
				}, 
				
				_isInt : function (value) {
					// summary:   Returns whether the passed value is int or not
					// tags: private
					// returns: boolean
					if ((parseFloat(value) == parseInt(value)) && !isNaN(value)) {
						return true;
					} else {
						return false;
					}
				}, 
				
				_getColumnIndex : function (colField) {
					// summary: Returns the column index for the column field.
					// tags: private
					// returns: Index of the column
					var cells = this._grid.structure;
					for (var i = cells.length - 1; i >= 0; --i) {
						var cell = cells[i];
						if (cell.field == colField) {
							return i;
						}
					}
					return null;
				}, 
				
				_filterHiddenColumns: function (structure){
					// summary: Returns the layout after filtering hidden column definition
					// tags: private
					// returns: layout object
					var filteredColumns = [];
					if(Lang.isArray(structure)){
						for(var i in structure) {
							var column = structure[i];
							if(!(column.hidden && column.hidden == true) ){
								filteredColumns.push(column);
							}
						}
					}
					if(filteredColumns.length >0 )this._currentLayout = filteredColumns;
					this._grid.setColumns(this._currentLayout);
					
				},
				refresh : function (updateBody) {
					// summary:	
					//		Calls in Grid refresh and handles filter applied
					// tags: public
					
					if (this._grid) {
						//Satanik: 5Apr2011: added for CURI store notification of refresh in progress
						if (this._grid.model.store.CURIRefresh) {
							this._grid.store.CURIRefresh();
							this._grid.model.clearCache();  // 49426
                            this._grid.body.refresh();   // 49426
						}
						
						//var scrollpos = this.grid.scrollTop;
						//filter should be applied only if previously applied
						/*if(this.grid.getFilter){
							//console.log("Grid has filter applied");
							//20610: Refresh on Table prompt for clear filters dialog when there are more than 2 filters set
							//Bobby:25May11, using new Grid API to suppress the Clear Filter warning on refresh 
							//LS - #24957 - 22/07/2011 - Problems with ruleCountToConfirmClearFilter - retaining the value set by user if any
							var preVal = this.grid.pluginMgr.getPlugin('filter').ruleCountToConfirmClearFilter;
							this.grid.pluginMgr.getPlugin('filter').ruleCountToConfirmClearFilter = Infinity; //Now the confirm dialog will never show
							var filterArray = this.getFilter();
							var ruleRelation = this.getFilterRelation();
							this.grid.setFilter(filterArray, ruleRelation);
							//LS - #24957 - 22/07/2011 - Problems with ruleCountToConfirmClearFilter - retaining the value set by user if any
							this.grid.pluginMgr.getPlugin('filter').ruleCountToConfirmClearFilter = preVal; //Now the confirm dialog will show
						}else {//as filter calls the grid refresh so adding the _refresh if filter is not there
							//console.log("Grid has NO filter applied");
							this.grid._refresh(true);
						}*/
						else {   // 49426
							//this.grid.setScrollTop(scrollpos);
							this._grid.model.clearCache();
							if(updateBody){
								this._grid.body.refresh();
							}
						}   // 49426
						
					}
				}, 
				
				removeSelectedRows : function () {
					// summary:   
					//		Removes the selected rows from the grid
					// tags: public
					
					this._grid.select.row.clear();
				}, 
				
				deleteAllRows : function () {
					// summary:   
					//		Deletes all rows from the grid.
					// tags: public
					
					var rowCount = this._grid.rowCount();
					for (var i = 0; i < rowCount; i++) {
						this.deleteRow(i);
					}
				}, 
				
				deleteRow : function (rowIndex) {
					// summary:  
					//		Delete a row with the  rowindex  specified.
					// rowIndex: number
					// tags: public
					
					var jsonStore = this._grid.store;
					var gridRef = this._grid;
					jsonStore.fetch({
						query : {},
						onComplete : function (items, request) {
							for (i = 0; i < items.length; i++) {
								var item = items[i];
								
								if (item) {
									jsonStore.deleteItem(item);
								}
							}
							//gridRef.body.refresh();
						}
					});
				}, 
				
				addToActionList : function (item) {
					// summary:  
					//		Add a new item to the toolbar action menu
					// tags: public
					// item: Object
					//		dijit MenuItem object	
					
					if (this._toolbar) {
						this._toolbar._addToActionList(item);
					}
				}, 
				
				addToToolbar : function (item, position, row, noResize) {
					// summary:  
					//		Add an item to the toolbar
					// item:  object   
					//		The item that needs to be added
					// position:  number 
					//		The position of the item in number
					// row:  number 
					//		The row number to which the item needs to be added
					// noResize: boolean 
					//		To control whether a table resize should be done or not
					// tags: public
	
					if (this._toolbar) {
						if (item) {
							this._toolbar._addCustomControl(item, position, row);
						}
						/* #8414: height issue - call resize on this widget whenever toolbar layout is modified, 
						this way new toolbar height can be calculated and grid can be resized accordingly*/
						//20May2011: Bobby
						//performance issue when multiple items are added to toolbar (Sunset/Analytics)
						if(noResize == false){}
						else this.resize();						
					}
				}, 
				
				addItemsToToolbar : function (items, position, row, noResize) {
					// summary:  
					//		Add list of items to toolbar
					// items:  array   
					//		The items that needs to be added
					// position:  number 
					//		The position of the item in number
					// row:  number 
					//		The row number to which the item needs to be added
					// noResize: boolean 
					//		To control whether a table resize should be done or not
					// tags: public
					
					if (this._toolbar) {
						for (var i = 0; i < items.length; i++) {		
							if (items[i]) {
								this._toolbar._addCustomControl(items[i], position + i, row);
							}
						}
						/* #8414: height issue - call resize on this widget whenever toolbar layout is modified, 
						this way new toolbar height can be calculated and grid can be resized accordingly*/
						//20May2011: Bobby
						//performance issue when multiple items are added to toolbar (Sunset/Analytics)
						if(noResize == false){}
						else this.resize();				
					}
				}, 		
				
				addCustomMenuToTable : function (position, customMenu) {
					// summary:  
					//		Add custom menu to the table
					// position: number 
					//		The position of the menu in number
					// customMenu: object  
					//		dijit menu
					// tags: public
					
					if (position == "headerMenu" || position == "headercell") {
						var menuArgs = {hookPoint: "headercell"};
						this.bindMenu(customMenu.id,menuArgs );
						
					} else if (position == "rowMenu" || position == "row") {
						var menuArgs = {hookPoint: "row"};
						this.bindMenu(customMenu.id,menuArgs );
						
					} else if (position == "cellMenu" || position == "cell" ) {
						var menuArgs = {hookPoint: "cell"};
						this.bindMenu(customMenu.id,menuArgs );
						
					} else if (position == "selectedRegionMenu") {
						
						var menuArgs = {hookPoint: "row", selected: true};
						this.bindMenu(customMenu.id,menuArgs );
					}
				}, 
				
				removeFromActionList : function (menuItemId) {
					// summary:    
					//		Removes the given menu item from the action list
					// menuItemId: string
					//		id of the menu item of type dijit MenuItem to be removed form action list
					//tags: public
					
					if (this._toolbar) {
						this._toolbar._removeFromActionList(menuItemId);
					}
				}, 
				
				enableMenuItem : function (menuItemId) {
					// summary:	
					//		Enables the given menu item
					// menuItemId: string
					//		id of the menu item of type dijit MenuItem to be enabled
					//tags: public
					
					if (this._toolbar) {
						this._toolbar._enableMenuItem(menuItemId);
					}
				}, 
				
				disableMenuItem : function (menuItemId) {
					// summary:	
					//		Disables the given menu item
					// menuItemId: string
					//		id of the menu item of type dijit MenuItem to be disabled
					//tags: public
					
					if (this._toolbar) {
						this._toolbar._disableMenuItem(menuItemId);
					}
				}, 
				
				removeItemFromToolbar : function (itemId) {
					// summary:	
					//		Removes an item  with the given item id from the toolbar
					//itemId: number  
					//	id of the item
					//tags: public
					
					if (this._toolbar) {
						this._toolbar._removeItem(itemId);
					}
				}, 
			
				addRow : function (item) {
					// summary:  
					//		Adds a row to the table and scroll to it
					// item: object
					//		row item/object to be added to the end of the table
					// tags:   public
					
					if (this._grid) {
						this.clearSort();
						this.clearFilter();
						var g = this._grid;
						setTimeout(function () {
							var itemAdded = g.store.newItem(item);
							var rowIndex = g.rowCount() - 1;
							if(g.vScroller)
								g.vScroller.scrollToRow(rowIndex);
							}, 10);
					}
				},
				
				clearSort : function (updateBody) {
					// summary:  
					//		Clears sorting for all columns
					// tags: public
					
					if(this._grid.sort && this._grid.sort.clearSort){
						this._grid.sort.clearSort(!updateBody);
					}else if(this._grid.sort && this._grid.sort.clear){
						//nested sort
						this._grid.sort.clear();
						
					}
				}, 
				
				slidingPaneClicked : function () {
					// summary:
					//		callback when collapsible tool bar sliding pane is clicked
					// tags: callback
					
					this.resize();
				},
				
				//Satanik:5May2011: destroy method is changed for mem leak issue 
				destroy : function () {
					// summary:  
					//		Destroys the grid.
					// tags: public
					try{
						delete this.resources_;
						//this is for destroying child templated widgets 
						//this should happen by itself but need to figure out why dijit._Templated is not taking care of it...
						var widgets = dijit.findWidgets(this.domNode);
						dojo.forEach(widgets, function(w) {
							if(w){
								if(w.destroyRecursive){
									w.destroyRecursive();
								} else if(w.destroy){
									w.destroy();
								}
							}
						});
						// this is for widgets added as child to this widget and their children..
						//not present in template
						var widgetArr = this.getChildren();
						dojo.forEach(widgetArr, function (child) {
							if(child){
								if(child.destroyRecursive){
									child.destroyRecursive();
								} else if(child.destroy){
									child.destroy();
								}
							}
						});
						this.inherited(arguments);
					}catch(ex){
						console.warn("Widget destroy failed: "+this.id+", ex="+ex.name+":"+ex.message);
					}
				},
				setFilter : function (filterObjArray, hideFilterBar) {
					// summary:  
					//		Sets the filter for the grid.
					// filterObjArray: Array
					//		 an array of filter objects
					// hideFilterBar: boolean 
					//		to indicate Fitler bar should be hidden
					// tags: public
								
					if (this._grid.filter) {
						var toFilterList = new ArrayList();
						if (filterObjArray) {
							for (var i = 0; i < filterObjArray.length; i++) {
								var filterObj = filterObjArray[i];
								if (filterObj.value) {
									if ((filterObj.column) && (this._isInt(filterObj.column) == false)) {
										filterObj.column = this._getColumnIndex(filterObj.column);
									}	
									var objToSet = {};
									if(filterObj.column && filterObj.column != "anycolumn"){
										objToSet = {
											"type" : filterObj.type ? filterObj.type : "string", 
											"colId" : filterObj.column ? filterObj.column : "anycolumn", 
											"value" : filterObj.value, 
											"condition" : filterObj.condition ? filterObj.condition : "contain"
										};
									}else{
										//anyColumn do not set colId
										objToSet = {
											"type" : filterObj.type ? filterObj.type : "string", 
											"value" : filterObj.value, 
											"condition" : filterObj.condition ? filterObj.condition : "contain"
										};
									}
									
									toFilterList.add(objToSet);
								}
							}
							var toFilterArray = toFilterList.toArray();
							var ruleRelation = filterObjArray.ruleRelation;
							var filter = {};
							if(ruleRelation == "logicAll"){
								filter = {"type":"all","conditions":toFilterArray };
							}else {
								filter = {"type":"any","conditions":toFilterArray };
							} 
							this._grid.filterBar.applyFilter(filter);
						} else {
							this.clearFilter()
						}
						if(hideFilterBar == true){
							this._grid.filterBar.hide();
						}else this._grid.filterBar.show();
					}
				}, 
				
				_setFilterData: function(filterData, hideFilterBar){
					// summary:  
					//		Sets the filter for the grid. This invokes gridx api to apply filter, refer gridx FilterBar module for data format
					// filterData: Object
					//		 Filter data 
					// hideFilterBar: boolean 
					//		to indicate Fitler bar should be hidden
					// tags: public
					if (this._grid.filter && this._grid.filterBar) {
						this._grid.filterBar.applyFilter(filterData);	
					}
					if(hideFilterBar == true){
						this._grid.filterBar.hide();
					}else this._grid.filterBar.show();
				},
				
				clearFilter : function (hideFilterBar) {
					// summary:   
					//		Clears the filter applied 	
					// hideFilterBar: boolean
					//		to hide filterbar when filter is cleared
					// tags: public
					
					if (this._toolbar && this._toolbar._quickFilter) {
						//console.warn('clearing quick filter....');
						this._toolbar._quickFilter._clearQuickFilter();
					} 
					if (this._grid.filter && this._grid.filter.getFilter()) {
						//console.warn('clearing grid filter....');
						this._grid.filter.setFilter(null);				
					}
					if(hideFilterBar == true){
						this._grid.filterBar.hide();
					}
				},
					
				_exportGrid : function (writer, exporterArgs) {
					var deferred = null;
					if(this._grid.exporter){
						if(writer == "csv"){
							deferred = this._grid.exporter.toCSV(exporterArgs);
						}else{
							deferred = this._grid.exporter.toTable(exporterArgs);
						}
					}
					return deferred;
				},
				_printGrid : function (printerArgs) {
					var deferred = null;
					if(this._grid.printer){
						deferred = this._grid.printer.print(printerArgs);
						
					}
					return deferred;
				},
				_printPreviewGrid : function (printerArgs) {
					var deferred = null;
					if(this._grid.printer){
						deferred = this._grid.printer.toHTML(printerArgs);
						
					}
					return deferred;
				},
				
				_bindMenu: function(/* dijit.Menu|ID */ menu, /* __MenuArgs? */ args) {
					
					this._grid.menu.bind(menu, args);
				},
				
				_unbindMenu: function(/* dijit.Menu|ID */ menu) {
					this._grid.menu.unbind(menu);
				}
				
				
			});
			
			
		return Table;
});
        
       
        