// wrapped by build app
define("dojoe/tablex/_TableOptions", ["dijit","dojo","dojox","dojo/i18n!dojoe/tablex/nls/Table","dojo/require!dijit/_Widget,dijit/_TemplatedMixin,dijit/_Container,dijit/form/CheckBox,dojoe/tablex/_ColumnVisible"], function(dijit,dojo,dojox){
dojo.provide("dojoe.tablex._TableOptions");

dojo.require("dijit._Widget");
dojo.require("dijit._TemplatedMixin");
dojo.require("dijit._Container");
dojo.require("dijit.form.CheckBox");
dojo.require("dojoe.tablex._ColumnVisible");

// NLS
dojo.requireLocalization("dojoe.tablex", "Table");
// define the widget class
dojo.declare (
	"dojoe.tablex._TableOptions",[ dijit._Widget, dijit._Container ],{
	
	// summary:
	//		Private class for Configure columns widget
	
	grid: null,
	_structure: [],
	constructor: function() {
		// summary: A reusable widget for displaying a dynamic set of parameters to be 
		//  filled in at runtime.
	    this.resources_ = dojo.i18n.getLocalization("dojoe.tablex", "Table", this.lang);
	},
	postCreate: function() { 
		this.inherited ("postCreate", arguments);	
		/*LS - 13/01/2012 - 30956 - Unresponsive script msg when using configure options */	
		//removing the indirect way of fetching columns through grid structure and getting it through layout.cells directly
		// this is improve performance of this feature reducing no of iterations...
		this.addColumnsVisible(this._structure);
	},
	addColumnsVisible: function (columns) {		
		var widget = null;
		var column = null;
		for (var i in columns) {
			if (i) {
				column = columns[i];
				
				if (column.field) {
					var visible = this._checkColumnVisible(column.field);
					widget = new dojoe.tablex._ColumnVisible ({
						id: this.id + "column_" + column.field,
						columnid: this.id + "column_" + column.field,
						checked: visible,  
						label: column.name
					});
					this.addChild(widget);
					//console.log ("added column widget");
				} else {
					//console.log ("this column was created internally by data store.  do not show it.");
				}
			}
		}
	},
	
	_checkColumnVisible: function(colField) {
		var cols = this.grid.structure;
		for (var i in cols) {
			if(i){
				if(cols[i].field == colField){
					return true;
				}
			}
		}
		return false;
	},
		
	onSelectAll: function(){		
		//for(var j=0; j<this.grid.structure.length; j++) {
			//var columns = this.grid.structure[j].rows;	
			//Anupama :24May11, replacing for..in construct with regular for loop since for..in construct interfering with changes in Array prototype in IE7.
			//26600: select all,de-select all feature in Table configure options dialog not working on IE7 browser.
			//for (var i in columns) {
			/*LS - 13/01/2012 - 30956 - Unresponsive script msg when using configure options */	
			//removing the indirect way of fetching columns through grid structure and getting it through layout.cells directly
			// this is improve performance of this feature reducing no of iterations...
			for(var k=0; k<this._structure.length; k++) {
				var column = this._structure[k];
				if (column && column.field) {
					var columnWidget = dijit.byId (this.id + "column_" +column.field);
					columnWidget.setVisible(true);	 
				}
			}		
		//}
	},
	onDeselectAll: function(){
		//for(var j=0; j<this.grid.structure.length; j++) {
			//var columns = this.grid.structure[j].rows;
			//Anupama :24May11, replacing for..in construct with regular for loop since for..in construct interfering with changes in Array prototype in IE7.
			//26600: select all,de-select all feature in Table configure options dialog not working on IE7 browser.
			//for (var i in columns) {
			/*LS - 13/01/2012 - 30956 - Unresponsive script msg when using configure options */	
			//removing the indirect way of fetching columns through grid structure and getting it through layout.cells directly
			// this is improve performance of this feature reducing no of iterations...
			for(var k=0; k<this._structure.length; k++) {
				var column = this._structure[k];
				if (column && column.field) {
					var columnWidget = dijit.byId (this.id + "column_" + column.field);
					columnWidget.setVisible(false);	 
				}
			}
		//}
	},
	onSave: function(){
	/*LS - 13/01/2012 - 30956 - Unresponsive script msg when using configure options */	
		//removing the indirect way of fetching columns through grid structure and getting it through layout.cells directly
		// this is improve performance of this feature reducing no of iterations...	
		var visibleCols = [];
		for(var k=0; k<this._structure.length; k++) {
			var column = this._structure[k];
			if(column && column.field) {
				var tblColumn = column;
				tblColumn.width = tblColumn.unitWidth;
				column.width = tblColumn.unitWidth;
				var columnWidget = dijit.byId (this.id + "column_" + column.field);
				column.hidden = !(columnWidget.isVisible());
				column.id = column.field
				//do not use setColumnVisibility, as each call for each cell makes a view update which is a overkill...
				//this.grid.layout.setColumnVisibility(k, columnWidget.isVisible());
				this._structure[k] = column;
				if(!column.hidden)visibleCols.push(this._structure[k]);	
				
			}
		}
		this.grid.setColumns(visibleCols);
		// persist the visible column information
		if(this.grid.persist){
			var config = {'configColumns':visibleCols };
			this.grid.persist.key = this.grid.id;
			this.grid.persist.put(this.grid.persist.key, config);
			this.grid.persist.registerAndLoad('configColumns', function(){
						return {
							visibleCols: visibleCols
						};
					});
			this.grid.persist.save();
		}
		
		
	},
	
	isColumnVisible: function (columnID) {
		var columnWidget = dijit.byId (this.id + "column_" + columnID);
		return (columnWidget.isVisible());
	}	
});

});
