define("dojoe/tablex/plugins/_MapToModules", ["dojo/_base/declare",
		"dojo/_base/array",
        "dojo/_base/lang",
    	"dojo/dom-class",
    	"dojo/dom-geometry",
    	"dojo/_base/query",
    	"dojo/window",
    	"dojo/dom-style",
		"gridx/modules/Body",
		"gridx/modules/Header",
		"gridx/modules/VirtualVScroller",
		"gridx/modules/Focus",
		"gridx/modules/ColumnResizer",
		"gridx/modules/SingleSort",
		"gridx/modules/select/Row",
		"gridx/modules/select/Cell",
		"gridx/modules/select/Column",
		"gridx/modules/extendedSelect/Cell",
		"gridx/modules/extendedSelect/Row",
		"gridx/modules/extendedSelect/Column",
		"gridx/modules/RowHeader",
		"gridx/modules/IndirectSelect",
		"gridx/modules/SummaryBar",
		"gridx/modules/pagination/Pagination",
		"gridx/modules/pagination/PaginationBar",
		"gridx/modules/pagination/PaginationBarDD",
		"gridx/modules/NestedSort",
		"gridx/modules/dnd/_Dnd",
		//"gridx/modules/move/Cell",
		//"gridx/modules/dnd/Cell",
		"gridx/modules/move/Column",
		"gridx/modules/move/Row",
		"gridx/modules/dnd/Row",
		"gridx/modules/dnd/Column",
		"gridx/modules/filter/Filter",
		"gridx/modules/filter/FilterBar",
		"gridx/modules/Menu",
		"gridx/modules/exporter/Exporter",
		"gridx/modules/exporter/Table",
		"gridx/modules/Printer",
		"gridx/modules/exporter/CSV",
		"gridx/modules/HLayout",
		"gridx/modules/VLayout",
		"gridx/modules/ColumnWidth"
	//	"dojoe/tablex/plugins/IndirectSelection"	
	], function (declare, array, lang, domClass, domGeometry, query, window, 
	domStyle, body, header, virtualVScroller, focus, columnResizer, singleSort, selectRow, selectCell, selectColumn, extSelCell, extSelRow, extSelColumn,
	rowHeader, indirectSelect, SummaryBar, pagination, paginationBar, paginationBarDD, nestedSort,_Dnd, /*MoveCell, DndCell,*/  
	 moveColumn, moveRow, dndRow, dndColumn, filter, filterBar, menu, exporter, exportTable, printer, exportCSV, HLayout, VLayout, ColumnWidth /* ,IndirectSelection*/) {
	
		var forEach = array.forEach;
		
		var mapToModules = declare("dojoe.tablex.plugins._MapToModules",[], {
			_modules: [],
			_coreModules: [
							header,
							body,
							virtualVScroller,
							focus,
							columnResizer,
							singleSort,
							//Latha: 05 Oct 2012 : Desired Selection Behavior broken in TWL 1.0.2 : removing ExtSelectCell as this module disturbs row selection.
					//		extSelCell,
							extSelRow,
					//		extSelColumn,
					//		rowHeader,
							//LS - 10/6/12 : modules to enable setting column width in the layout
							// Please do not set last column width in the layout so that it defaults to "auto" occupying the remaining space in the grid
							HLayout,
							VLayout,
							ColumnWidth
							
						 ],
			_plugins: null,

			_convertToModules: function (/*gridparams.plugins object*/plugins) {
				this._modules = [];
				this._modules = this._modules.concat(this._coreModules);
				for(var key in plugins) {
					if (plugins.hasOwnProperty(key)) {						
						switch(key){
							case "indirectSelection" :
								if( plugins[key]!= false){
									this._mapIndSelectAttrs(plugins[key]);
								}
								break;
							case "pagination" :
								if( plugins[key]!= false){
									this._mapPaginationAttrs(plugins[key]);
								}
								break;
							case "dnd" :
								if( plugins[key]!= false){
									this._mapDnDAttrs(plugins[key]);
								}
								break;
							case "sortFields" :
								//@189518 handled by nestedSorting plugin, TWL could probably combine
								break;
							case "nestedSorting" :
								if( plugins[key]!= false){
									this._mapNestedSortingAttrs(plugins[key], plugins["sortFields"]);	//@189518
								} else {
									this._mapSingleSortAttrs(plugins["sortFields"]);					//@189518					
								}
								break;
							case "filter" :
								if( plugins[key]!= false){
									this._mapFilterAttrs(plugins[key]);
								}
								break;
							case "menus" :
								if( plugins[key]!= false){
									this._mapMenuAttrs(plugins[key]);
								}
								break;
							case "printer" :
								if( plugins[key]!= false){
									this._mapPrinterAttrs(plugins[key]);
								}
								break;
							case "exporter" :
								if( plugins[key]!= false){
									this._mapExporterAttrs(plugins[key]);
								}
								break;
							case "selector" :
								if( plugins[key]!= false){
									this._mapSelectorAttrs(plugins[key]);
								}
								break;
							default: console.error('Plugin not supported: '+ key );
						}						
					}
				}
				return this._modules;				
			},
			
			_getCoreModules: function (){				
				return this._coreModules;
			},
			
			_mapIndSelectAttrs: function (pluginObj){
				var mdIndex = array.indexOf(this._coreModules, extSelRow);
				var rowSelectMod = 
					(mdIndex >=0)?{moduleClass:this._coreModules[mdIndex], triggerOnCell: true}
						:{moduleClass: extSelRow, triggerOnCell: true};
				var rowHeaderMod = {moduleClass: rowHeader};
				var indSelMod = {moduleClass: indirectSelect};
				//var indSelPlugin = {moduleClass: IndirectSelection};
				if(lang.isObject(pluginObj)){
					if(pluginObj.headerSelector == true){
						indSelMod.all = true;
					}
					if(pluginObj.multiple == false){
						rowSelectMod = {moduleClass: selectRow, triggerOnCell: true};
						rowSelectMod.multiple = false;
					}
				}
				if(mdIndex >= 0){
					this._coreModules[mdIndex] = rowSelectMod;
					this._modules.push(rowHeaderMod, indSelMod);	
				}else{
					this._modules.push(rowSelectMod,rowHeaderMod, indSelMod);	
				}
			},
			
			_mapSelectorAttrs: function(pluginObj) {
				var mdIndexSelRow = array.indexOf(this._coreModules, extSelRow);
				var selectRowMod = 
					(mdIndexSelRow >=0)? {moduleClass:this._coreModules[mdIndexSelRow], triggerOnCell: true}
						:{moduleClass: extSelRow, triggerOnCell: true};
				var selectCellMod = {moduleClass: extSelCell};
				var selectColumnMod = {moduleClass: extSelColumn};
				
				if(lang.isObject(pluginObj)){
					if(pluginObj.row == "single"){
						selectRowMod = {moduleClass: selectRow, triggerOnCell: true};
						selectRowMod.multiple = false;
					}
					if(pluginObj.cell == "single"){
						selectCellMod = {moduleClass: selectCell};
					}
					if( pluginObj.col == "single"){
						selectColumnMod = {moduleClass: selectColumn};
					}					
				}
				if(pluginObj.col != "disabled"){
					this._modules.push(selectColumnMod);
					
				}
				if(pluginObj.cell != "disabled"){
					this._modules.push(selectCellMod);
				}
				if(pluginObj.row != "disabled"){
					if(mdIndexSelRow >= 0){
						this._coreModules[mdIndexSelRow] = selectRowMod;
					}else{
						this._modules.push(selectRowMod);
					}
				}				
			},
			
			_mapDnDAttrs: function (){
				this._modules.push(
						{moduleClass: _Dnd}, 
						{moduleClass: extSelColumn},
					//	{moduleClass: MoveCell}, 
						{moduleClass: moveColumn},
						{moduleClass: moveRow}, 
					//	{moduleClass: DndCell},
						{moduleClass: dndRow},
						{moduleClass: dndColumn}
				);
			},
			
			_mapPaginationAttrs: function (pluginObj){
				var baseMod = {moduleClass: pagination};
				var paginationMod = {moduleClass: paginationBar};
				if( lang.isObject(pluginObj) && !pluginObj.onlyDesc ){
					for(var key in pluginObj) {
						if (pluginObj.hasOwnProperty(key)) {
							switch(key){
								case "defaultPageSize" :
									baseMod.initialPageSize = pluginObj[key];
									break;
								case "pageSizes" :
									paginationMod.sizes = pluginObj[key];
									break;
								case "description" :
									paginationMod.description = pluginObj[key];
									break;
								case "sizeSwitch" :
									paginationMod.sizeSwitch = pluginObj[key];
									break;
								case "pageStepper" :
									paginationMod.stepper = pluginObj[key];
									break;
								case "gotoButton" :
									paginationMod.gotoButton = pluginObj[key];
									break;
								case "maxPageStep" :
									paginationMod.visibleSteppers = pluginObj[key];
									break;
								case "position" :
									paginationMod.position = pluginObj[key];
									break;
								case "descTemplate" :
									paginationMod.descriptionTemplate = pluginObj[key];
									break;
								default: console.warn('Parameter not supported: '+ key 
										+ ' please use gridx modules instead of plugin to take advantage of extra configurations! ');
							}
						}
					}
					this._modules.push(baseMod,paginationMod);
				}
				
				if(lang.isObject(pluginObj) && pluginObj.onlyDesc == true){
					//description only so use SummaryBar 
					var summaryBarMod = {moduleClass: SummaryBar};
					this._modules.push(summaryBarMod);
				}				
			},
			
			//@189518 START
			_mapSingleSortAttrs: function(pluginObj) {
				var sort = {moduleClass: singleSort};
				sort.initialOrder = pluginObj;
				this._modules.push(sort);					
			},
			
			_mapNestedSortingAttrs: function (pluginObj, initialOrder){
				var nest = {moduleClass: nestedSort};
				nest.initialOrder = initialOrder;
				this._modules.push(
						//{moduleClass: body},
						//{moduleClass: header},
						nest
				);	
			},
			//@189518 END	
			
			_mapMenuAttrs: function(pluginObj) {
				this._modules.push({moduleClass: menu});
			},
			
			_mapFilterAttrs: function(pluginObj) {
				var baseMod = {moduleClass: filter};
				var filterBarMod = {moduleClass: filterBar};
				if(lang.isObject(pluginObj)){
					for(var key in pluginObj) {
						if (pluginObj.hasOwnProperty(key)) {
							switch(key){
								case "isServerSide" :
									baseMod.serverMode = pluginObj[key];
									break;	
								case "closeFilterbarButton" :
									filterBarMod.closeFilterBarButton = pluginObj[key];
									break;	
								case "ruleCountToConfirmClearFilter" :
									filterBarMod.ruleCountToConfirmClearFilter = pluginObj[key];
									break;		
								case "setupFilterQuery" :
									baseMod.setupFilterQuery = pluginObj[key];
									break;
								default: console.warn('Parameter not supported: '+ key 
										+ ' please use gridx modules instead of plugin to take advantage of extra configurations! ');
							}
						}
					}
				}
				this._modules.push(baseMod, filterBarMod);
			},
			
			_mapPrinterAttrs: function(pluginObj) {				
				this._modules.push({moduleClass:exporter}, {moduleClass:exportTable}, {moduleClass: printer});
			},
			
			_mapExporterAttrs: function(pluginObj){
				this._modules.push({moduleClass:exporter}, {moduleClass:exportCSV}, {moduleClass:exportTable});
			}			
		});
		
		mapToModules.convertToModules = function(plugins){
			return mapToModules.prototype._convertToModules(plugins);
		};
		mapToModules._getCoreModules = function(){
			return mapToModules.prototype._getCoreModules();
		};
	
		return mapToModules;
	}
);