// wrapped by build app
define("dojoe/toolbar/_Toolbar", ["dijit","dojo","dojox","dojo/i18n!dojoe/table/nls/Table","dojo/require!dijit/form/Button,dijit/ToolbarSeparator,dijit/_Widget,dojo/i18n,dijit/_Templated"], function(dijit,dojo,dojox){
dojo.provide("dojoe.toolbar._Toolbar");

dojo.require("dijit.form.Button");
dojo.require("dijit.ToolbarSeparator");
dojo.require("dijit._Widget");
dojo.require("dojo.i18n");
dojo.require("dijit._Templated");

dojo.requireLocalization("dojoe.table", "Table");

dojo.declare("dojoe.toolbar._Toolbar", [ dijit._Widget, dijit._Templated], {	

		templateString:dojo.cache("dojoe.toolbar", "templates/Toolbar.html", "<div  dojoAttachEvent='oncontextmenu:_stopEvent' class=\"tivTable dijitToolbar\" width=\"100%\">\r\n<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\" role=\"presentation\">\r\n\t<tbody>\r\n\t\t<tr valign=\"center\">\r\n\t\t\t<td width=\"80%\" height=\"100%\">\r\n\t\t\t\t<span dojoAttachPoint=\"toolbarFirstRow\">\r\n\t\t\t\t\t<span dojoAttachPoint=\"toolbarFirstRow_userItems\">\r\n\t\t\t\t\t</span>\r\n\t\t\t\t</span>\r\n\t\t\t</td>\r\n\t\t\t<td width=\"20%\" height=\"100%\" align=\"right\">\r\n\t\t\t\t<div dojoAttachPoint=\"quickFilterNode\" role=\"search\">\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t\t<td>\r\n\t\t\t\t<div dojoAttachPoint=\"filterNode\" role=\"button\">\r\n\t\t\t\t</div>\r\n\t\t\t</td>\t\t\t\r\n\t\t</tr>\r\n\t\t<tr valign=\"center\">\r\n\t\t\t<td width=\"100%\">\r\n\t\t\t\t<span dojoAttachPoint=\"toolbarSecondRow\">\r\n\t\t\t\t</span>\t\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t</tbody>\t\t\r\n</table>\r\n</div>"),
		widgetsInTemplate:true,
		_resources:null,
		
		// Constructor function. Called when instance of this class is created
		constructor : function() {
			this._resources = dojo.i18n.getLocalization("dojoe.table", "Table", this.lang);			
		},
		
		// To add the item/icon to the toolbar.
		
		_addIcon: function(item) {
			if (item != null) {
				var itemNode = dojo.doc.createElement("span", {role : "button"}); 
				dojo.style(itemNode, "width", "1px"); 
				if(item.iconClass == "refreshIcon") {
					dojo.place(itemNode,this.toolbarFirstRow,"first");
				} else {
					dojo.place(itemNode,this.toolbarFirstRow,"last");
				}
				itemNode.appendChild(item.domNode);
			}
		},
		
		// To add the toolbar seperator to the toolbar.
		
		_addToolbarSeperator: function() {
			var seperatorNode = dojo.doc.createElement("span"); 
			var seperator = new dijit.ToolbarSeparator({id: "refSeperator"+this.id});
			dojo.style(seperatorNode, "width", "1px"); 
			dojo.place(seperatorNode,this.toolbarFirstRow,1);
			seperatorNode.appendChild(seperator.domNode);
		},
		
		//do not call this method directly, use table.addToToolbar(item,position,row) method to add a custom item to the toolbar before default buttons
		_addToToolbarFirstRow: function(item, position){
			if (item != null) {
				var itemNode = dojo.doc.createElement("span"); 
				dojo.style(itemNode, "width", "1px"); 
				if(position !== undefined){
					dojo.place(itemNode, this.toolbarFirstRow_userItems, parseInt(position));
				}else {
					dojo.place(itemNode, this.toolbarFirstRow_userItems, 'last');
				}
				itemNode.appendChild(item.domNode);
			}
		},
		
		//do not call this method directly, use table.addToToolbar(item,position,row) method to add a custom item to the toolbar second row
		_addToToolbarSecondRow: function(item, position){
			if (item != null) {
				var itemNode = dojo.doc.createElement("span"); 
				dojo.style(itemNode, "width", "1px"); 
				if(position !== undefined){
					dojo.place(itemNode, this.toolbarSecondRow, parseInt(position));
				}else {
					dojo.place(itemNode, this.toolbarSecondRow, 'last');
				}
				itemNode.appendChild(item.domNode);
			}
		}
		
	});
});
