require({cache:{
'url:dojoe/treetablex/templates/TreeTable.html':"\r\n<div class=\"tivTreeTable\" tabIndex=0 aria-label=\"tree table\" role=\"application\">\r\n\t<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\"  style=\"width:100%;height:100%;\"  role=\"presentation\">\t\t\r\n\t\t<tr valign=\"center\">\r\n\t\t\t<td width=\"100%\" role=\"toolbar\">\r\n\t\t\t\t<div dojoAttachPoint=\"wipeNode\">\r\n\t\t\t\t\t<div dojoAttachPoint=\"toolbarNode\"></div>\r\n\t\t\t\t</div>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr valign=\"center\">\r\n\t\t\t<td width=\"100%\" role=\"treegrid\">\r\n\t\t\t\t<div dojoAttachPoint=\"treeGridNode\"></div>\t\r\n\t\t\t</td>\r\n\t\t</tr>\t\t\r\n\t</table>\r\n</div>\t"}});
define("dojoe/treetablex/TreeTable", [
	"dojo/_base/declare",
	"dijit/_Widget",
	"dijit/_TemplatedMixin",
	"gridx/Grid",
	"gridx/core/model/cache/Async",
	"gridx/core/model/extensions/Query",
	"gridx/modules/Persist",
	"gridx/modules/Tree",
	"gridx/modules/VirtualVScroller",
	"gridx/modules/ColumnResizer",
	"gridx/modules/SingleSort",
	"gridx/modules/select/Row",
	"gridx/modules/select/Column",
	"gridx/modules/extendedSelect/Row",
	"gridx/modules/extendedSelect/Column",
	"gridx/modules/IndirectSelect",
	"gridx/modules/RowHeader",
	"gridx/modules/filter/Filter",
	"gridx/modules/filter/FilterBar",
	"dojo/dom-geometry",
	"dojoe/treetablex/_Toolbar",
	"dojoe/slidingpane/SlidingPane",
	"dojoe/treetablex/modules/StatefulRefresh",
	"dojo/_base/array",
	"dojo/_base/lang",
	"dojo/window",
	"dojo/dom-style",
	"dojo/i18n!dojoe/treetablex/nls/TreeTable",
	"dojo/text!./templates/TreeTable.html"
], function (declare, _Widget, _TemplatedMixin, Gridx, Cache, Query, Persist, Tree, VirtualVScroller, ColumnResizer, SingleSort, SelectRow, SelectColumn, ExtSelectRow, ExtSelectColumn, IndirectSelect, RowHeader, Filter, FilterBar, domGeom , _Toolbar, SlidingPane, StatefulRefresh, array, Lang, Window, domStyle, _resources, template) {

	//summary: 
	//		Tree table is a hybrid widget of a tree and table 
	//description: 
	//		TreeTable widget implementation is based gridx
	//		Provides additional features upon gridx like toolbar with state control buttons (refresh) and custom actions dropdown etc

	TreeTable = declare('dojoe.treetablex.TreeTable', [_Widget, _TemplatedMixin], {
	
		//summary: Set this to true if the widget contains other widgets
		//tags: private
		widgetsInTemplate : true,
		
		//summary: Path to the template
		//tags: private
		templateString: template,
		
		// _grid: Object
		//		Reference to the gridx used
		_grid: null,
		
		// gridParams_: object
		//		holds all the parameters passed to the gridx by the user.
		gridParams_: null,
		
		// filterOptions:  Object
		//		Holds all the filter information passed by the user.
		filterOptions : {},
		
		// mods: object
		//		holds the modules passed to the gridx.
		_modules: [ Tree, VirtualVScroller, SelectRow, SelectColumn, SingleSort, ColumnResizer],
		
		// mods: object
		//		holds the filter modules passed to the gridx.
		_filterModules: null,
		
		// mods: object
		//		holds the indirect selection modules and its dependencies passed to the gridx.
		_indirectSelectModules: null,
		
		// toolbarVisible: boolean
		//		control the _toolbar show/hide
		toolbarVisible:true,
		
		// enableCollapsibleToolbar: boolean
		//		To add collapsible toolbar  to the table
		enableCollapsibleToolbar : false,
		
		// toolbarExpand: boolean
		//		To indicate(preset) the state of the toolbar on load
		toolbarExpand : false,
		
		//enableResize: boolean
		//		To disable table resize on window resize event.Default true, set false to disable table resize on window resize event	
		enableResize:true,		
		
		// width: number in px or % or em
		//		holds the width of the grid
		width:'',
		
		// height: number in px or % or em
		//		holds the height of the grid
		height:'',
		
		// _defaultHeight: number in %
		//		holds the default height of the grid
		_defaultHeight: '100%',
		
		// _defaultWidth: number in % 
		//		holds the default width of the grid
		_defaultWidth: '100%',
		
		//summary: Reference to the toolbar
		//tags: private
		_toolbar:null,
		
		// toolbarOptions: object
		//	holds the list of values for enabling/disabling toolbar options
		toolbarOptions:null,
	
		// state: object
		//		Tree Grid state object
		state: null,
		
		// enableColumnReorder: boolean
		//		To enable column reorder, by default its true
		enableColumnReorder:true,
		
		// indirectSelection: boolean
		//		Set tree table with basic Selection, if set to true enables Indirect selection Single and multiple grid selection modes
		indirectSelection: false,
		
		//menu: object
		// 		To handle custom menus
		menu: null,
		
		//summary: keeps track of the menu event object which provides the context value when right clicked
		onContextMenuEvtObj: null,
		
		// _originalStructure: original Structure set to the table
		// tags: private
		_origLayout : null,
		
		// _currentLayout: layout object after filtering columns with hidden parameters
		// tags: private
		_currentLayout : null,
		
		//_selectionMode: string
		// 		To handle selection mode. by default it is single 
		_selectionMode : "single",
		
		constructor: function(args){
			// summary: Constructor
			this.gridParams_ = {};
			this.actionList = {};
			//this._modules = [ Tree, VirtualVScroller, SelectRow, SelectColumn, SingleSort, ColumnResizer, Persist];
			this._filterModules = [Filter, FilterBar];
			this._indirectSelectModules = [IndirectSelect, RowHeader];
		},
		
		postCreate: function(){
			//summary: 
			//		creates and initialize the tree table 
		
			this._mapGridParams();
			this._defineModules();
			// set statefulRefresh in gridparams if the expansion state needs to be persisted during dynamic updates..
			if(this.gridParams_.statefulRefresh){
				this._modules.push(Persist);
				this._modules.push(StatefulRefresh);
			
			}
			if( !this.gridParams_.autoWidth){
				domStyle.set(this.domNode, "width", this.width);
			}
			if( !this.gridParams_.autoHeight){
				domStyle.set(this.domNode, "height", this.height);
			}
			this._makeGrid();
			// set statefulRefresh in gridparams if the expansion state needs to be persisted during dynamic updates..
			// statefulRefresh is a new module on Gridx which when loaded enables persisting the expansion state
			
			if(this.gridParams_.statefulRefresh){
				this.connect(this, "onRefresh",dojo.hitch(this._grid.statefulRefresh,"_applyTreeState")) ;
				
			}
			if(this.menu !== null){
				this.connect(this._grid, "onRowContextMenu", dojo.hitch(this, "showRowContextMenu"));
			}	
			if(this.toolbarVisible ){
				this._toolbar = new _Toolbar({treeTable:this}, this.toolbarNode);
				
				if (this.enableCollapsibleToolbar) {
					this.slidingPane = new SlidingPane({closeNodeClass: "slidingPaneClose", open: this.toolbarExpand}, this.wipeNode);
					this.connect(this.slidingPane, "onClick", dojo.hitch(this, "slidingPaneClicked"));	//Connecting event onClick to sliding pane.
				}
				
			} else {
				if(this.filterOptions.hideFilterBar == true && this._grid.filterBar !== undefined){
					this._grid.filterBar.hide();
				} 
			}
			this.resize();
			if(this.enableResize === true) {
				this.connect(window, "onresize", dojo.hitch(this, "resize"));			
			}
			
			if(this._toolbar && this._toolbar.actionListWidget){	
				this.connect(this._toolbar.actionListWidget, 'openDropDown', dojo.hitch(this,"onActionListOpen")); 			
				this.connect(this._toolbar.actionListWidget, 'closeDropDown', dojo.hitch(this,"onActionListClose")); 
			}
			
			if(this.gridParams_.preFilter){
				dojo.connect(this, 'onTreeTableLoad', dojo.hitch(this,"_preFilter"));
			}
			setTimeout(dojo.hitch(this, "onTreeTableLoad", this), 1000);
		},
		onTreeTableLoad: function(treetable){
			// summary: 
			//		Called after the tree Table loads
			// tags:
			//      callback
			console.info("TreeTable load complete....."+treetable.id);
		},
		showRowContextMenu: function(e){
			//summary: 
			//		Associates row context menu with tree table and also returns the contextEvent Object
			//tags: public
			e.preventDefault();
			if(this.menu){
				this.menu._openMyself({
					target: e.target,
					coords: "pageX" in e ? {
						x: e.pageX,
						y: e.pageY
					} : null
				});
			}
			this.onContextMenuEvtObj = e;
			return e;
		},	
		
		_defineModules: function() {
			this._modules = this._modules.concat(this._filterModules);
			if(this._selectionMode == 'single') {
				this._modules = this._modules.concat({moduleClass: SelectRow, multiple : false, treeMode: false, triggerOnCell : true});
			} else if(this._selectionMode == 'multiple') {
				this._modules = this._modules.concat([ExtSelectRow, ExtSelectColumn]);	
				this._modules = this._modules.concat({moduleClass: ExtSelectRow, triggerOnCell : true});
			}
			if(this.gridParams_.modules) {
				this._modules = this._modules.concat(this.gridParams_.modules);			
			}
			if(this.indirectSelection) {
				this._modules = this._modules.concat(this._indirectSelectModules);			
			}
		},
		
		_mapGridParams: function() {
			//if no width is given default is set
			if(this.width ===''&& !this.gridParams_.autoWidth){
				this.width = this._defaultWidth;
			}
			//if no height is given default is set
			if(this.height ==='' && !this.gridParams_.autoHeight){
				this.height = this._defaultHeight;
			}
			if(this.gridParams_.indirectSelection){
				this.indirectSelection=this.gridParams_.indirectSelection;
			}
			if(this.gridParams_.selectionMode){
				this._selectionMode=this.gridParams_.selectionMode;
			}
			
		},
		
		slidingPaneClicked : function () {
			// summary:
			//		callback when collapsible tool bar sliding pane is clicked
			// tags: callback
			this.resize();
		},
		
		_makeGrid: function(){
			
			// summary: 
			//		creates and initializes gridx
			// tags: private
			
			var store =  this.gridParams_.store;
			if(!this.gridParams_.cacheClass){
				this.gridParams_.cacheClass = Cache;
			}
			this.gridParams_.modules = this._modules;
			if(!this.gridParams_.modelExtensions){
				this.gridParams_.modelExtensions = [Query];
			}
	
			this._grid=new Gridx(this.gridParams_,this.treeGridNode);
			if (!("hasChildren" in store)) {	
					store.hasChildren = function(id, item){
						return item && store.getValues(item, 'children').length;
					};
			}
			if (!("getChildren" in store)) {	
					store.getChildren = function(item){
						return store.getValues(item, 'children');
					};
			}
			
		/*	if(!this.gridParams_.noDataMessage){
				this.grid.noDataMessage=this._resources.NO_DATA;
			}
			else{
				this.grid.noDataMessage=this.gridParams_.noDataMessage;
			} */
		
			this._grid.startup();	
			//set original column structure to keep a reference of overall structure including hidden columns
			if(this.gridParams_.structure && !this._origLayout){
				this._origLayout = this.gridParams_.structure;
						
			}
			// set filtered structure in case hidden parameters are present
			this._filterHiddenColumns(this._origLayout);
				
			
		},
		_filterHiddenColumns: function (structure){
			// summary: Returns the layout after filtering hidden column definition
			// tags: private
			// returns: layout object
			var filteredColumns = [];
			if(Lang.isArray(structure)){
				for(var i in structure) {
					var column = structure[i];
					
					if(!(column.hidden && column.hidden == true) ){
						filteredColumns.push(column);
					}else if(i==0 || column.expandLevel == 1){
						//root node do not hide it...
						filteredColumns.push(column);
					}
				}
			}
			if(filteredColumns.length >0 )this._currentLayout = filteredColumns;
			this._grid.setColumns(this._currentLayout);
			
		},
		
		resize: function (event) {
			// summary:  
			//		Resizes the tree table. Also takes care of window resize events
			// tags:  public
			// event: object
			//		window resize event
			
			if (!this._grid || !this.domNode || !this.domNode.parentNode || this.domNode.parentNode.nodeType != 1) {  //Javascript error in resize() sometimes on IE8
				return;
			}
			
			if (!this._grid.autoWidth) {
			domStyle.set(this.domNode, "width", this.width);
			} else {
				domStyle.set(this.domNode, "width", domGeom.getMarginBox(domNode).w + 'px');
			}
			if (!this._grid.autoHeight) {
			domStyle.set(this.domNode, "height", this.height);
			} else {
				domStyle.set(this.domNode, "height", domGeom.getMarginBox(domNode).h + 'px');
			}
			
			var resizeEvent = false;
			if(event && event.currentTarget){
				resizeEvent = true;
			}
			
			var heightPx = this.height;
			var size = Window.getBox();
				
			if (!(this.domNode.parentNode.style && this.domNode.parentNode.style.height)) {
				var sizeType = this.height.substring(this.height.length - 1, this.height.length);
				//if the height is given in % then translate it to pixel
				if (sizeType == "%") {
					//convert to px
					heightPx = size.h * ((parseInt(this.height.slice(0, -1))) / 100);
					heightPx = heightPx + "px";
				}
			}
		
			domStyle.set(this.domNode, "height", heightPx);
			setTimeout(dojo.hitch(this, function(){this._delayResize(event);}), 100);
		},
		
		_delayResize: function (event) {
			// summary:  
			//		invoked with delay for grid resize.
			// tags: private
			
					
			/*using marginBox to include margins/borders of the domNode*/
			var tableSize =  domGeom.getMarginBox(this.domNode);
					
			if (this._toolbar) {
				/*calculating toolbarsize including margins and borders as they contibute to some height*/
				var toolbarSize = domGeom.getMarginBox(this._toolbar.domNode);
				//removing grid padding height which will be later added when pagination bar is placed and grid view node is resized.
				tableSize.h = tableSize.h - toolbarSize.h;				
			}
			if((tableSize.h <= 0 || tableSize.w <= 0 )){
				return;
			}
			if(event && event.currentTarget){
				this._grid.resize({
					h : tableSize.h,
					w : tableSize.w
				});
			}else{
				this._grid.resize({
					h : tableSize.h,
					w : tableSize.w
				});
			}
			
			if(this.enableCollapsibleToolbar) {
						if(this.slidingPane!=null && !this.slidingPane.open) {
							tableSize.h = tableSize.h + toolbarSize.h ;
							this._grid.resize({
								h : tableSize.h,
								w : tableSize.w
							});
						}
			} 
		},
		
		onActionListOpen : function(){
			// summary:
			//		Callback when toolbar Action list is opened
			// tags: public
		
			//console.info("actionListOpen.....");
			
		},
		
		onActionListClose : function(){
			// summary:
			//		Callback when toolbar Action list is closed
			// tags: public
			
			//console.info("actionListClosed.....");
			
		},
		
		_preFilter : function(){
			// summary: 
			//		Private function to set "gridparams.preFilter" value when tree table loads
			// tags: private
			
			if (this.gridParams_.preFilter) {
					if(this.gridParams_.preFilter[0].column==='any'){
						//is.grid._cleanup(); 
						//this.grid._clearData();
						if(this.gridParams_.preFilter[0].value){
							this.setFilter(this.gridParams_.preFilter[0].value);
						}
					}
			}
		},
		
		setFilter : function (filterText){
			//summary:
			//		set filter value programmatically
			// tags: public
			if(this._toolbar){
				if(this._toolbar.quickFilter){
					this._toolbar.quickFilter._setFilter(filterText);
				}
			}
		},
		
		getFilter : function(){
			// summary:
			//		get filter value
			// tags: public
			
			if(this._toolbar){
				if(this._toolbar.quickFilter){
					return this._toolbar.quickFilter._getFilter();
				}
			}
		},
		
		addToActionList: function(item) {
			// summary: 
			//		To add a new item to the toolbar action menu
			// tags: public
			
			if(this._toolbar) {
				if(this._toolbar.actionMenu) {
					this._toolbar.actionListWidget.dropDown.addChild(item,0);
				}
			}
		},
		
		addToToolbar : function (item, position, row, noResize) {
			// summary:  
			//		Add an item to the toolbar
			// tags: public
			// item:  object   
			//		The item that needs to be added
			// position:  number 
			//		The position of the item
			// row:  number 
			//		The row number to which the item needs to be added
			// noResize: boolean 
			//		To control whether a table resize should be done or not
		
			if (this._toolbar) {
				if (item) {
					this._toolbar._addCustomControl(item, position, row);
				}
				if (noResize == false){
				} else {
				this.resize();	
				}
			}
		}, 
		
		addItemsToToolbar : function (items, position, row, noResize) {
			// summary:  
			//		Add a list of items to the toolbar
			// tags: public
			// items:  array   
			//		The items that needs to be added
			// position:  number 
			//		The position of the starting item 
			// row:  number 
			//		The row number to which the item needs to be added
			// noResize: boolean 
			//		To control whether a table resize should be done or not
		
			if (this._toolbar) {
				for (var i = 0; i < items.length; i++) {		
					if (items[i]) {
						this._toolbar._addCustomControl(items[i], position + i, row);
					}
				}
				if (noResize == false){
				} else {
				this.resize();	
				}			
			}
		}, 		
		
		addContextMenuToTreeTable: function(position, customMenu){
			// summary: 
			//		Allows adding a context menu to the TreeTable
			//tags: public
			
			if(position == "rowMenu") {
				customMenu.bindDomNode(this.grid.domNode);
				this.grid.onRowContextMenu = function(e){				
					if(!this.menu){
						this.menu = customMenu;
					}
				};
			}
		},
		
		removeItemFromToolbar: function(itemId){
			// summary: 
			//		to remove an item from the toolbar
			// tags: public
			// itemId: String
			if(this._toolbar) {
				this._toolbar._removeItem(itemId);
			}			
		},
	
		removeFromActionList: function (menuItemId){
			// summary: 
			//		Removes a menu Item from ActionList
			// tags: public
			// menuItemId : String
			//		Id of the menuItem to be removed.
			if(this._toolbar) {
				this._toolbar._removeFromActionList(menuItemId);
			}
		},
		
		getRowCount : function(){
			// summary: 
			//		rowCount of the table
			// tags: public
			// return: number
			//		the rowCount	
			return this._grid.rowCount();
		},
		
		getSelectedRowCount : function(){
			// summary: 
			//		Gets a selected rowCount of the table
			// tags: public
			// return: number
			//		the selected rowCount
			return this._grid.select.row.getSelected().length;
		},
		
		getSelectedRows : function(){
			// summary:  
			//		Returns the selected rows from the grid.
			// tags: public
			// returns: array
			//		selected rows.
			return this._grid.select.row.getSelected();
		},	
		
		isRowSelected: function(rowId){
			// summary: 
			//		Returns true if given row is selected
			// tags: public
			
			return this._grid.select.row.isSelected(rowId);
		},
		
		disableMenuItem : function(menuid){
			// summary: 
			//		Disable a menu item of the context menu attached to the treetable.
			// tags: public
			
			var menuitem= dijit.byId(menuid);
			if(menuitem) {
				menuitem.setDisabled(true);
			}
		},
		
		enableMenuItem : function(menuid){
			// summary:
			//		Enable a menu item of the context menu attached to the treetable.
			// tags: public
			var menuitem= dijit.byId(menuid);
			if(menuitem) {
				menuitem.setDisabled(false);
			}
		},
		
		removeSelectedRows : function(){
			// summary: 
			//		deletes selected rows from the treetable
			// tags: public
			
			var grid = this._grid;
			var selectedArray = grid.select.row.getSelected();
			array.forEach(selectedArray, function(row){
				var item = grid.row(row, true).item();
				console.log("item..");
				console.log(item);
				grid.store.deleteItem(item);
			});
		},
		
		deleteRow: function(item){
			// summary: 
			//		deletes the given item from the store
			// tags: public
			// item: object
			//		Row element of the table
			this._grid.store.deleteItem(item);
		},
	
		removeItemFromToolbar: function(itemId){
			// summary: 
			//		to remove an item from the toolbar
			// tags: public
			// itemId: String
			if(this._toolbar) {
				this._toolbar._removeItem(itemId);
			}			
		},
		
		addRow: function(item,parent) {
			// summary: 
			//		Adds a new row to the treetable 
			// tags: public
			// description: 
			//		If no parent id is given, then the new row will be added as the last row.
			//      If parent id is given, then the row will be added as the last child of the parent.
			// item: object
			//		The item to be added
			// parent: string
			//		The parent id to which the new row should be added as a child
			
			//If the row is selected to be as a parent then the new row will be added as a child to that row.
			if(this._toolbar){
				if(this._toolbar.quickFilter && this._toolbar.quickFilter.filterText !== null){
					this._toolbar.quickFilter._clearFilter();
				}
				this._toolbar._clearSort();
			}
			if(!parent){
				if(this._grid){
					var selectedItem = this._grid.store.newItem(item);
				}
			}else{
				var s = this._grid.store;
				s.fetchItemByIdentity({identity: parent, onItem: function(item){
					parent = item;
				}});
				if(parent){
					s.newItem(item, {parent: parent, attribute: "children"});
				}
				this._grid.body.refresh();
			}
		},
		
		removeMenuItem : function (menuid){
			// summary: 
			//		Removes menu item from the context menu
			// tags: public
			var menuitem= dijit.byId(menuid);
			if(menuitem) {
				menuitem.destroyRecursive();
			}
		},
			
		refresh: function(updateBody) {
			// summary: 
			//		Refreshes the grid with updated values. If updateBody is true it refreshes the grid body also. 
			// tags: public
			var deferred = null;
			if (this._grid) {
				if (this._grid.model.store.CURIRefresh) {
					// Refresh is being driven by change to CURI dataset
					// on the server
					this._grid.store.CURIRefresh();
					// Since CURI dataset could have significant changes
					// can't count on selected item(s) to still be there
					// and can't count on tree expanded branch states, so
					// have to clear all of them (unless we can find out
					// from gridx team how to gracefully handle cases where
					// old child items no longer exist or have different IDs now.
	                this._grid.select.row.clear();
	                this._grid.model.clearCache();
	                this._grid.tree._clear();
	                deferred =  this._grid.body.refresh();  // Got to redraw all rows
				}
				else {
					this._grid.model.clearCache();
					if (updateBody) {
						deferred = this._grid.body.refresh();
					}					
				}
				var t = this;
				deferred.then(function(value){
					t.onRefresh();
				});
			}

			return deferred ;
		},
		
		onRefresh: function() {
			// summary:  
			//		Callback on tree table refresh. Connect to this to perform some actions after gridx refresh is complete
			// tags: public	
		},
		
		destroy: function(){
			// summary:  
			//		Destroys the tree table.
			// tags: public	
			
			// memory leak issue: custom destroy method to take care of removing all widgets					
			try{
				if(this.menu){
					this.menu.destroyRecursive();
				}
				delete this.resources_;			
				//this is for destroying child templated widgets 
				//this should happen by itself but need to figure out why dijit._Templated is not taking care of it...
				var widgets = dijit.findWidgets(this.domNode);
				dojo.forEach(widgets, function(w) {
					if(w){
						if(w.destroyRecursive){
							w.destroyRecursive();
						} else if(w.destroy){
							w.destroy();
						}
					}
				});
				// this is for widgets added as child to this widget and their children..
				//not present in template
				var widgetArr = this.getChildren();
				dojo.forEach(widgetArr, function (child) {
					if(child){
						if(child.destroyRecursive){
							child.destroyRecursive();
						} else if(child.destroy){
							child.destroy();
						}
					}
				});
				this.inherited(arguments);
			}catch(ex){
				console.warn("Widget destroy failed: "+this.id+", ex="+ex.name+":"+ex.message);
			}
		}	
		
	});
	
	return TreeTable;
});