require({cache:{
'url:dojoe/treetablex/templates/QuickSearchFilter.html':"<div class=\"dijitReset  dijitTextBox quickFilter\" dojoAttachEvent='onmouseover:_onHover,mouseleave:_onUnHover,onblur:_onBlur,onclick: _onClick'>\r\n\t<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\" role=\"presentation\">\r\n\t\t<tbody>\r\n\t\t\t<tr valign=\"center\">\r\n\t\t\t\t<td width=\"98%\" height=\"100%\">\r\n\t\t\t\t\t<div class=\"dijitReset  dijitInputContainer\">\t\t    \r\n\t\t\t\t\t\t<input dojoAttachPoint=\"searchField\" title=\"${_resources.QUICK_FILTER}\" class=\"dijitInputInner qf-textfield\" type=\"text\" \r\n\t\t\t\t\t\t\tvalue=\"${_resources.QF_DEFAULT_TEXT}\" valign=\"middle\" tabindex=\"0\"\r\n\t\t\t\t\t\t\tdojoAttachEvent='onfocus:_onFocus,onclick:_onClick,onkeyup:_onKeyUp,onpaste:_onKeyUp,oncut:_onKeyUp,onKeyPress:_onKeyUp' role=\"textbox\"/>\t\r\n\t\t\t\t\t</div>\r\n\t\t\t\t</td>\t\r\n\t\t\t\t<td width=\"2%\" height=\"100%\">\r\n\t\t\t\t\t<div class=\"dijitReset  dijitArrowButtonContainer \">\r\n\t\t\t\t\t\t<button title=\"${_resources.CLEAR_FILTER}\" class=\"dijitReset quickFilterClearInner\" type=\"button\" tabindex=\"0\" \r\n\t\t\t\t\t\t\tvalign=\"middle\"  dojoAttachPoint='clearFilterNode' dojoAttachEvent='onclick:_onCancel,onkeypress:_onCancel' role=\"button\"></button>\t\t\t\r\n\t\t\t\t\t</div>\r\n\t\t\t\t</td>\r\n\t\t\t</tr>\r\n\t\t</tbody>\t\t\r\n\t</table>\r\n</div>"}});
define("dojoe/treetablex/_QuickSearchFilter", [
	"dojo/_base/declare",
	"dijit/_Widget",
	"dijit/_TemplatedMixin",
	"dijit/_WidgetsInTemplateMixin",
	"dojo/dom-style",
	"dojo/dom-class",
	"dojo/i18n!dojoe/treetablex/nls/TreeTable",
	"dojo/text!./templates/QuickSearchFilter.html"
	], function (declare, _Widget, _TemplatedMixin,_WidgetsInTemplateMixin, domStyle, domClass, resourceBundle , template) {

		_QuickSearchFilter = declare('dojoe.treetablex._QuickSearchFilter', [_Widget, _TemplatedMixin, _WidgetsInTemplateMixin], {	

		// summary:
		//		Private class to create and handle Quick Search Filter on the Tree table toolbar
		// tags: private
	
		// Path to the template
		templateString : template, 
		
		// Set this to true if your widget contains other widgets
		widgetsInTemplate : true, 
		grid : null, 
		handle : null, 
		filterText : null, 
		filterLayer : null, 
		filterOptions : null, 
		_quickFilterButton: false, //change filter on type based on this	
		_quickFilterDelay: 700,	//delay in ms before quick filter is applied as typed	
		_ruleCntClearFilter: null,		
		_resources: null,
		
		// Override this method to perform custom behavior during dijit construction.
		// Common operations for constructor:
		// 1) Initialize non-primitive types (i.e. objects and arrays)
		// 2) Add additional properties needed by succeeding lifecycle methods
		constructor : function () {
			this._resources = resourceBundle;
		}, 
		
		postCreate : function () {
			if(this.filterOptions){
				if(this.filterOptions.showQuickFilterButton !== undefined) {
					this._quickFilterButton = this.filterOptions.showQuickFilterButton;
				}
				if(this.filterOptions.quickFilterDelay) {
					this._quickFilterDelay = this.filterOptions.quickFilterDelay;
				}
			}
			//disabling clear filter icon when there is no filter applied to avoid above confusion	
			if(this.filterText !== null && this.filterText !== "" )	{
				domStyle.set(this.clearFilterNode, "display", "block");
			}else{
				domStyle.set(this.clearFilterNode, "display", "none");
			}		
		}, 		
		
		// When this method is called, all variables inherited from superclasses are 'mixed in'.
		// Common operations for postMixInProperties
		// 1) Modify or assign values for widget property variables defined in the template HTML file
		postMixInProperties : function () {
			 
		}, 
		
		_parseDecimal : function (v) {
			return parseInt(v, 10);
		}, 
		
		_onFocus : function () {
			//return if grid._loading a variable indicating the grid loading is true
			if(this.grid._loading) return;
			domClass.add(this.domNode, 'dijitTextBoxFocused');
			if (this.searchField.value == this._resources.QF_DEFAULT_TEXT) {
				//Richa- Color settings should be there in css files
				//this.searchField.style.color = "#000000";
				this.searchField.value = "";
			}
		}, 
		
		_onClick : function () {
			//return if grid._loading a variable indicating the grid loading is true
			if(this.grid._loading) return;
			domClass.add(this.domNode, 'dijitTextBoxFocused');
			this.searchField.focus();
			//Richa- Color settings should be there in css files
			//this.searchField.style.color = "#000000";
			if (this.searchField.value == this._resources.QF_DEFAULT_TEXT) {
				this.searchField.value = "";
			}
		},
		
		_onBlur : function () {
			domClass.remove(this.domNode, 'dijitTextBoxFocused');
			domClass.remove(this.domNode, 'dijitTextBoxHover');
			if (!this.searchField.value) {
				this.searchField.style.color = "#999999";
				this.searchField.value = this._resources.QF_DEFAULT_TEXT;
			}
		}, 
		
		_onHover : function () {
			//LS- 26/10/2011 - # 30377 - Treetable - incorrect results when setting filter or sorting while data is being loaded
			//return if grid._loading a variable indicating the grid loading is true
			if(this.grid._loading) return;
			domClass.add(this.domNode, 'dijitTextBoxHover');
		}, 
		
		_onUnHover : function () {
			domClass.remove(this.domNode, 'dijitTextBoxHover');
		}, 
		
		_onKeyUp : function (event) {	
			//return if grid._loading a variable indicating the grid loading is true
			if(this.grid._loading) return;
			//tab & shift keys		
			//console.info("key -"+ event.keyCode);	
			this.filterText = this.searchField.value;
			if(event){
				if (event.keyCode == 9 || event.keyCode == 16) {
					return;
				}else if(this._quickFilterButton && event.keyCode !== 13){
					return;
				}			
				//console.log("filter ---"+this.filterText);
				if (event.keyCode == 13) {
					dojo.stopEvent(event);
					this._setFilter();
					return;
				}
			}
			this.onChangeFilterText();
		}, 
		
		_onCancel : function (event) {			
			//tab & shift keys	
			if(event.keyCode == 9 || event.keyCode == 16) {
				//Bobby:17Apr2011, tab gets stuck if stopped
				//dojo.stopEvent(event);
				return;
			}else{
				this._clearFilter();			
			}			
		}, 
		
		_clearFilter : function () {
			if(this.grid.filterBar && this.grid.filterBar.filterData && this._savedCriteria) {
			 var filterExp = this.grid.filterBar.filterData;
			 var filterArr = filterExp.conditions;
			 console.info(this._savedCriteria.conditions[0].value);
	 		 for(var i=0;i<filterArr.length;i++){
					
				if(!(filterArr[i].colId )&& (this._savedCriteria.conditions[0].value == filterArr[i].value) ){
					filterArr.splice(i,1);
					break;
			 	}
	 		 }
			 if(filterArr.length > 0){
				filterExp.conditions = filterArr;
				this.grid.filterBar.applyFilter(filterExp);
			 }else{
				this.grid.filterBar.clearFilter();
			 }
			 	
		}	
		this.searchField.style.color = "#999999";
		this.searchField.value = this._resources.QF_DEFAULT_TEXT;
		dojo.style(this.clearFilterNode, "display", "none");
		}, 
		_setFilter : function (filterText){
			if(filterText !== undefined && filterText !==''){
				this.filterText=filterText;
				this.searchField.value=filterText;
			}
			var input = this.searchField.value;
	   		if (input == this._resources.QF_DEFAULT_TEXT || input == "") {
				input = "";
				this._clearFilter();
				return;
			}
			var filterData  = {"type":"any", "conditions":
			[{  "type": "string",
			  "condition": "contain",
			  "value": input,
			  "colTxt": "Any Column",
			  "condTxt": "contain",
			  "formattedVal": input
			  }]};
			if(this._savedCriteria){
				var previousCriteria = this._savedCriteria;
			}
			this._savedCriteria = filterData;
			if(this.grid.filterBar && this.grid.filterBar.filterData){
				var filterSet = false;
				var filterObj = this.grid.filterBar.filterData;
				if(previousCriteria){
					for(var i=0; i< filterObj.conditions.length; i++){
						if(!(filterObj.conditions[i].colId)  && (previousCriteria.conditions[0].value == filterObj.conditions[i].value) ){
							filterObj.conditions[i].value = filterData.conditions[0].value;
							filterSet = true;
							break;
						}
					}
					if(filterSet)filterData = filterObj;
				} else if(filterObj){
					filterObj.conditions = filterObj.conditions.concat(filterData.conditions);
					console.dir(filterObj);
					filterData = filterObj;
				}
			}
			this._ruleCntClearFilter = this.grid.filterBar.ruleCountToConfirmClearFilter;
			this.grid.filterBar.ruleCountToConfirmClearFilter = 'Infinity';
			this.grid.filterBar.applyFilter(filterData);	
			dojo.style(this.clearFilterNode, "display", "block");	
		}, 
		
		_getFilter : function(){
			return this.filterText;
		},
			
		_enableQuickFilter: function(fitleredSize, totalSize) {
			if(this.clearFilterNode && this.clearFilterNode.style.display == "none" &&
				(this.filterText && this.filterText !=="" && this.searchField.value != this._resources.QF_DEFAULT_TEXT )){
					dojo.style(this.clearFilterNode, "display", "block");
				}
			if(this.searchField && this.searchField.disabled == true){
				this.searchField.disabled = false;
				if(this.filterText && this.filterText !=="" && this.searchField.value != this._resources.QF_DEFAULT_TEXT ){
					this.searchField.focus();
					//Richa- Color settings should be there in css files
					//this.searchField.style.color = "#000000";
				}else if (!this.searchField.value || this.searchField.value == this._resources.QF_DEFAULT_TEXT ){
					this.searchField.style.color = "#999999";
					this.searchField.value = this._resources.QF_DEFAULT_TEXT;
				}
			}
			//this.disconnect(this.fetchEnableFilterHandler);
			
		},
		
		_disableQuickFilter: function() {
			if(this.clearFilterNode && this.clearFilterNode.style.display == "block"){
				dojo.style(this.clearFilterNode, "display", "none");
			}
			if(this.searchField && this.searchField.disabled == false){
				this.searchField.disabled = true;
				this._onBlur();
				this.searchField.style.color = "#999999";
			}
		},
		
		onChangeFilterText : function () {
			if (this.handle) {
				clearTimeout(this.handle);
				this.handle = null;
			}
			var fnc = dojo.hitch(this, this._setFilter, this.filterText);
			this.handle = setTimeout(fnc, this._quickFilterDelay);
		}, 
		
		destroy: function(){
			// summary:  Destroys the toolbar.
			// tags: public	
			//memory leak issue: custom destroy method to take care of removing all widgets					
			try{
				delete this._resources;
				//this is for destroying child templated widgets 
				//this should happen by itself but need to figure out why dijit._Templated is not taking care of it...
				var widgets = dijit.findWidgets(this.domNode);
				dojo.forEach(widgets, function(w) {
					if(w){
						if(w.destroyRecursive){
							w.destroyRecursive();
						} else if(w.destroy){
							w.destroy();
						}
					}
				});
				// this is for widgets added as child to this widget and their children..
				//not present in template
				var widgetArr = this.getChildren();
				dojo.forEach(widgetArr, function (child) {
					if(child){
						if(child.destroyRecursive){
							child.destroyRecursive();
						} else if(child.destroy){
							child.destroy();
						}
					}
				});
				this.inherited(arguments);
			}catch(ex){
				console.warn("Widget destroy failed: "+this.id+", ex="+ex.name+":"+ex.message);
			}
		} 	
	});
	return _QuickSearchFilter;
	
});
