// wrapped by build app
define("dojoe/wizard/TivSubstep", ["dijit","dojo","dojox","dojo/require!dojoe/wizard/Page"], function(dijit,dojo,dojox){
dojo.provide("dojoe.wizard.TivSubstep");

dojo.require("dojoe.wizard.Page");

/**
 * An extension that is a substep
 * For the wizard, it handles substeps.
 */
dojo.declare("dojoe.wizard.TivSubstep", [dojoe.wizard.Page], 
	{
		mainPage: null,  // main page for this substep
		
		constructor: function (args) {
		},

		isMainStep: function () {
			return (false);
		},
  
		isPartOfLoop: function () {
			if (this.mainPage.isPartOfLoop()) {
				return (true);
			} else {
				return (false);
			}
		},
  
		/**
		* Nested substeps are not supported
		*/
		hasSubsteps: function () {
			return (false);
		},
  
		getMainPage: function () {
			return (this.mainPage);
		},
  
		/** 
		* These items are created with some minor differences in how they are
		* displayed
		*/
		buildTOCRendring: function () {
			var listItemToAdd = this.listItem;
			// if the list entry hasn't been created yet
			if (this.listItem == null) {
				// create it
				this.inherited(arguments);
				// save main page for this substep
				this.mainPage = this.wizard.getPreviousMainPage(this);
				// if vertical toc
				if ('v' === this.wizard.layout) {
					listItemToAdd = this.listItem;
					// make it invisible
					dojo.style(this.listItem, "display", "none");
					// and indented
					dojo.addClass(this.listItem, "tiv-wiz-toc-substep");
				} else {
					// horizontal mode - add to substep list of main page
					listItemToAdd = null;
					if (this.mainPage != null) {
						if (this.mainPage.substepsList == null) {
							this.mainPage.substepsList = dojo.create("ol", {});
						}
						this.mainPage.substepsList.appendChild(this.listItem);
					}        
				}
			}
			return listItemToAdd;
		}
	});
});
