define("dojox/grid/enhanced/plugins/ToolBar", [
	'dojo',
	'dijit/Toolbar',
	'dijit/form/Button',
	'../_Plugin',
	'../../EnhancedGrid'
], function(dojo, Toolbar, Button, _Plugin, EnhancedGrid){

var ToolBar = dojo.declare('dojox.grid.enhanced.plugins.ToolBar', _Plugin, {

	name: 'toolbar',

	constructor: function(grid, args){
		var tb = this.toolbar = new Toolbar({});
		dojo.addClass(tb.domNode, 'dojoxGridToolBar');
		tb.placeAt(grid.viewsHeaderNode, 'before');
		var oldFunc = dojo.hitch(grid, grid._getHeaderHeight);
		grid._getHeaderHeight = function(){
			return oldFunc() + dojo.marginBox(tb.domNode).h;
		};
		
		this.grid.focus.addArea({
			name: 'toolbar',
			onFocus: dojo.hitch(this, this._onFocus)
		});
		this.grid.focus.placeArea('toolbar', 'before', 'header');

		//For demo/test only
		tb.addChild(new Button({
			showLabel: false,
			iconClass: 'dojoxGridToolBarRefreshBtnIcon',
			onClick: function(){
				grid.showMessage(grid.loadingMessage);
				setTimeout(dojo.hitch(grid, grid._refresh), 200);
			}
		}));
	},

	destroy: function(){
		this.toolbar.destroyRecursive();
	},

	_onFocus: function(evt){
		var children = this.toolbar.getChildren();
		if(children.length){
			children[0].focus();
			if(evt && evt.stopPropagation){
				dojo.stopEvent(evt);
			}
			return true;
		}
		return false;
	}
});

EnhancedGrid.registerPlugin(ToolBar);

return ToolBar;
});

