// wrapped by build app
define("ibm/tivoli/tip/dijit/tests/tivwizard_pages/TestPage6", ["dijit","dojo","dojox","dojo/require!ibm/tivoli/tip/dijit/TivPage,dijit/Dialog"], function(dijit,dojo,dojox){
dojo.provide("ibm.tivoli.tip.dijit.tests.tivwizard_pages.TestPage6");

dojo.require("ibm.tivoli.tip.dijit.TivPage");
dojo.require("dijit.Dialog");

dojo.declare("ibm.tivoli.tip.dijit.tests.tivwizard_pages.TestPage6", [ibm.tivoli.tip.dijit.TivPage], 
{
  templateString:"<div class=\"page6\">\r\n  <div class=\"tiv-page-header\">\r\n    <h2>Page 6</h2>\r\n  </div>\r\n  <div class=\"tiv-page-content\">\r\n    <h4>Page 6</h4>\r\n    <div><input dojoAttachPoint=\"_disableCancel\" type=\"checkbox\" />Disable Cancel button</div>\r\n    <div><input dojoAttachPoint=\"_connectCancel\" type=\"checkbox\" />Connecting Cancel button</div>\r\n    <div><input dojoAttachPoint=\"_overrideBackNext\" type=\"checkbox\" />Override Back and Next buttons</div>\r\n    <div><input dojoAttachPoint=\"_resetButton\" type=\"button\" value=\"Reset\" /></div>\r\n  </div>\r\n</div>\r\n",
  title: "Page 6",
  preventDefault: false,
  backConnLink: null,
  nextConnLink: null,
  cancelConnLink: null,
  
  postCreate: function()
  {
    dojo.connect(this._disableCancel, "onclick", this, this.disableCancel);
    dojo.connect(this._connectCancel, "onclick", this, this.connectCancel);
    dojo.connect(this._overrideBackNext, "onclick", this, this.overrideBackNext);
    dojo.connect(this._resetButton, "onclick", this, this.reset);
  },
  
  disableCancel: function()
  {
    this.wizard.enableCancelButton(!this._disableCancel.checked);
  },
  
  connectCancel: function()
  {
    if (this._connectCancel.checked)
      this.cancelConnLink = dojo.connect(this.wizard, "OnCancel", this.clickCancelHandler);
    else
      dojo.disconnect(this.cancelConnLink);
    
  },

  overrideBackNext: function()
  {
    if (this._overrideBackNext.checked) {
      this.preventDefault = true;
      this.backConnLink = dojo.connect(this.wizard, "_onClickBack", this.clickBackHandler);
      this.nextConnLink = dojo.connect(this.wizard, "_onClickNext", this.clickNextHandler);
    }
    else {
      this.preventDefault = false;
      dojo.disconnect(this.backConnLink);
      dojo.disconnect(this.nextConnLink);
      this.backConnLink = null;
      this.nextConnLink = null;
    }
  },
  
  allowBack: function()
  {
    if (this.preventDefault)
      return false;
    else
      return true;
  },
  
  allowNext: function()
  {
    if (this.preventDefault)
      return false;
    else
      return true;    
  },
  
  clickCancelHandler: function(event)
  {
    console.log("TestPage6.clickCancelHandler");
    //event.preventDefault();     // so that the browser does not follow link
    var dialog = new dijit.Dialog({ title: "Cancel button click handler",
                                    style: "width:300px;height:200px",
                                    content: "Connecting Cancel button..."                                             
                                  });
    dialog.show();
  },
  
  clickBackHandler: function(event)
  {
    console.log("TestPage6.clickBackHandler");
    event.preventDefault();     // so that the browser does not follow link
    var dialog = new dijit.Dialog({ title: "Back button click handler",
                                    style: "width:300px;height:200px",
                                    content: "Overriding default behavior of Back button..."                                             
                                  });
    dialog.show();
  },
  
  clickNextHandler: function(event)
  {
    console.log("TestPage6.clickNextHandler");    
    var dialog = new dijit.Dialog({ title: "Next button click handler",
                                    style: "width:300px;height:200px",
                                    content: "Overriding default behavior of Next button..."                                             
                                  });
    dialog.show();
  },  

  AfterPageSelected: function()
  {
    this.wizard.resetFinishLabel("Finish");
    this.wizard.enableFinishButton(true);
  },

  reset: function()
  {
    console.log("TestPage6.reset");
    this._disableCancel.checked = false;
    this._connectCancel.checked = false;
    this._overrideBackNext.checked = false;
    this.preventDefault = false;
    dojo.disconnect(this.cancelConnLink);
    dojo.disconnect(this.backConnLink);
    dojo.disconnect(this.nextConnLink);
    this.backConnLink = null;
    this.nextConnLink = null;
    this.cancelConnLink = null;
  }
});

});
