// wrapped by build app
define("ibm/tivoli/tip/navwidget/dijit/AsynchContextMenu", ["dijit","dojo","dojox","dojo/i18n!ibm/tivoli/tip/dijit/nls/resources","dojo/require!dijit/Menu,dijit/MenuItem,ibm/tivoli/tip/dijit/TIPContextMenu,ibm/tivoli/tip/dijit/TIPContextMenuProvider"], function(dijit,dojo,dojox){
/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * "Restricted Materials of IBM"
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.dijit.AsynchContextMenu");

dojo.require("dijit.Menu");
dojo.require("dijit.MenuItem");
dojo.require("ibm.tivoli.tip.dijit.TIPContextMenu"); 
dojo.require("ibm.tivoli.tip.dijit.TIPContextMenuProvider");

dojo.requireLocalization("ibm.tivoli.tip.dijit", "resources");

dojo.declare("ibm.tivoli.tip.navwidget.dijit.AsynchContextMenu",
        ibm.tivoli.tip.dijit.TIPContextMenu,
{		
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	loadingMenuItemID: "LOADING_ID",
	processingLabel: null,
	
	constructor: function(){
        this.processingLabel = dojo.i18n.getLocalization("ibm.tivoli.tip.dijit", "resources").PROCESSING;
    },
    
    _destroyMenu: function() {  // 37703
        this.inherited(arguments);
        this.cmProvider.cancelPendingRequest();
    },    
    
 	_loadMenuItems: function() {
		// summary:
		//		If the menu is currently empty (i.e., just created), return the placeholder
		//		menu item and tell the asynch provider to get the menu items asynchronously,
		//		otherwise, remove the placeholder and ask the provider for the menu items
		//		now that the asynch request has returned the menu items.
		var items = null;
		var contextMenu = this.getMenu();
		if (contextMenu != null) {
			var childItems = contextMenu.getChildren();
			if (childItems.length == 0) {
				items = [{ 
        				"label": this.processingLabel,
        				"iconClass": "tipMenuIcon loadingIcon", 
        				"actionID": this.loadingMenuItemID,
        				"launchType": "NOOP"
        				}];
				this.cmProvider.getMenuItemsAsynch(this._context, dojo.hitch(this, this._menuItemsLoaded));
			}
			else {
				this._removeLoadingItem();
				items = this.cmProvider.getMenuItems(this._context);
			}
		}
		return items;
 	},
 	
 	_menuItemsLoaded: function(/*Boolean*/ success) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
 		// success:
 		//		
 		
		var menu = this.getMenu();
 		if (success) {
 			// repopulate menu
 			this.populateMenu(menu);
 			// the menu is already marked as started, so populateMenu skips these
 			// steps, so do them again here
 			dojo.forEach(menu.getChildren(), function(child){ child.startup(); });
 			menu.startupKeyNavChildren();
 			// The dijit.Menu still remembers the "Loading..." item as focused so reset
 	        menu.focusedChild = null;
 	        menu.focus();
 		}
 	    else {
 	    	// There were either no tasks returned or an error occurred, so dismiss the context menu
 	    	dijit.popup.close(menu);
 	    }
 	},
 	
 	_removeLoadingItem: function() {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
 		var contextMenu = this.getMenu();
	    var childItems = contextMenu.getChildren();
 	    var loadingItem = childItems[0];
 	 	contextMenu.removeChild(loadingItem);
 	 	loadingItem.destroy();
 	}
	
	
});       // 256005  Split AsynchContextMenuProvider and RESTContextMenuProvider to separate files for Dojo 1.7 rules, one module per file


});
