// wrapped by build app
define("ibm/tivoli/tip/navwidget/table/dijit/NavModelTableSelection", ["dijit","dojo","dojox","dojo/require!ibm/tivoli/tip/navwidget/dojo/NavWidgetPluggableViewSelection,ibm/tivoli/tip/navwidget/dojo/NavWidgetUtil,dojox/collections/SortedList"], function(dijit,dojo,dojox){
/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * �Restricted Materials of IBM�
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.table.dijit.NavModelTableSelection");

dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewSelection");
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil");
dojo.require("dojox.collections.SortedList");

dojo.declare(
    "ibm.tivoli.tip.navwidget.table.dijit.NavModelTableSelection",
    ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewSelection,
    {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
    	
    	setMode: function(mode){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
    		// mode:
    		//		
    	
	    	//We know the pluggableView is a Item or Links Table View, so we can set the selection mode on the grid's selection object
    		this._pluggableView._table._grid.selection.setMode(mode);   // 49426  Gridx
	    	
			//Call superclass
    		this.inherited(arguments);
		},
    	
	 	setSelectedObjectIds: function(/*String[]*/ itemIds, /*String[]*/ linkIds, /*String[]*/ relationshipIds){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// itemIds:
			//		
			// linkIds:
			//		
			// relationshipIds:
			//			
			
	    	//Mark we're changing
			this._changing = true;
			
			//We know the pluggableView is a Item or Links Table View
			if (!this._pluggableView._handlingSelectionChangedCallback) { //Don't do anything if pluggable view is currently dealing with user-initiated selection
				//Clear selection
				var grid = this._pluggableView._table._grid;   // 49426  Gridx
				
				// 49426  this._pluggableView._grid.selection.clear();
				// NOTE: for gridx this would need to be grid.select.row.clear()
			    //  ...but since we have no way (yet) of looking up an item by
			    //  it's itemId in the gridx table's model to get the row...we can't support this now
				// (unless...looks like rowId may equal itemId...need to verify that and revisit this
			    console.log("ERROR: setSelectedObjectIds not supported yet for GRIDX based table");
			    grid.selection.clear();
				
				//Deal with items
				if (itemIds) {
					for (var i = 0; i < itemIds.length; i++) {
						var item = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getItemByAbsoluteId(this._dataset, itemIds[i]);
						var idx = grid.getItemIndex(item);    // 49426  Gridx
						if (idx >= 0) {
							grid.selection.addToSelection(idx);  // 49426  Gridx
						}
					}
				}
				
				//Deal with links
				if (linkIds) {
					for (var i = 0; i < linkIds.length; i++) {
						var link = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getLinkByAbsoluteId(this._dataset, linkIds[i]);
						var idx = grid.getItemIndex(link);  // 49426  Gridx
						if (idx >= 0) {
							grid.selection.addToSelection(idx);   // 49426  Gridx
						}
					}
				}
				
				//Deal with relationships
				if (relationshipIds) {
					for (var i = 0; i < relationshipIds.length; i++) {
						var relationship = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getRelationshipByAbsoluteId(this._dataset, relationshipIds[i]);
						var idx = grid.getItemIndex(relationship);   // 49426  Gridx
						if (idx >= 0) {
							grid.selection.addToSelection(idx);   // 49426  Gridx
						}
					}
				}
			}
			
			//Call superclass
			this.inherited(arguments);
			
			//Mark we're done changing
			this._changing = false;
		},
		
	 	setSelectedObjects: function(/*ibm.tivoli.navmodel.Item[]*/ items, /*ibm.tivoli.navmodel.Link[]*/ links, /*ibm.tivoli.navmodel.Relationship[]*/ relationships, /*Integer[]*/rowIds){	// 49426  Gridx	
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			// items:
			// 		
			// links:
			//		
			// relationships:
			//		
			
			//Mark we're changing
			this._changing = true;
			
			//We know the pluggableView is a Item or Links Table View
			if (this._pluggableView._grid && !this._pluggableView._handlingSelectionChangedCallback) { //Don't do anything if pluggable view is currently dealing with user-initiated selection
				//Clear selection
				var grid = this._pluggableView._table._grid;  // 49426  Gridx
				// grid.select.row.clear();    remove for now...no longer needed?
				
				if (this._pluggableView.dataset) {
					//Deal with items
					// 49426  (next 5 lines)
					if (items && items.length > 0 && rowIds && rowIds.length > 0) {   
                        dojo.forEach(rowIds, function(rowId) {   
                           grid.select.row.selectById(rowId);
                        });
                    }
                    // need else case for calling in programmatically with only items
                    // but that will require lookup from item to row in Gridx
					
					//Deal with links
					// 49426  (next 5 lines)
					if (links && links.length > 0 && rowIds && rowIds.length > 0) {    
                        dojo.forEach(rowIds, function(rowId) {   
                           grid.select.row.selectById(rowId);
                        });
                    }
					
					//Deal with relationships
					// 49426  (next 5 lines)
					if (relationships && relationships.length > 0 && rowIds && rowIds.length > 0) {   
                        dojo.forEach(rowIds, function(rowId) {   
                           grid.select.row.selectById(rowId);
                        });
                    }
					
					grid.model.when();   // 49426  Gridx...Necessary?  Check with Gridx developers
				}
			}
			
    		//Call superclass
			this.inherited(arguments);
			
			//Mark we're done changing
			this._changing = false;
		},
		
		// 49426  Gridx
	    updateSelectedObjects: function(/*ibm.tivoli.navmodel.Item[]*/items, /*Integer[]*/rowIds) {  
	    	this._ignore = true;
	    	this.setSelectedObjects(items, null, null, rowIds);
	    	this._ignore = false;
	    }
		
    }
);
});
