// wrapped by build app
define("ibm/tivoli/tip/navwidget/tree/dijit/TreeTableSelection", ["dijit","dojo","dojox","dojo/require!ibm/tivoli/tip/navwidget/dojo/NavWidgetPluggableViewSelection,ibm/tivoli/tip/navwidget/dojo/NavWidgetUtil"], function(dijit,dojo,dojox){
/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * �Restricted Materials of IBM�
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("ibm.tivoli.tip.navwidget.tree.dijit.TreeTableSelection");

dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewSelection");
dojo.require("ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil");

dojo.declare("ibm.tivoli.tip.navwidget.tree.dijit.TreeTableSelection", ibm.tivoli.tip.navwidget.dojo.NavWidgetPluggableViewSelection, {
	// data members
	_ignore: false,
	
	setMode: function(mode){
		this._pluggableView._table._grid.selection.setMode(mode);
		
		// Call superclass
		this.inherited(arguments);
	},
	
	setSelectedObjectIds: function(/*String[]*/itemIds, /*String[]*/linkIds, /*String[]*/relationshipIds) {
		// Mark we're changing
		this._changing = true;
		
		if (!this._ignore) {			
			// Clear selection
			var grid = this._pluggableView._table._grid;
			
			// NOTE: for gridx this would need to be grid.select.row.clear()
			//  ...but since we have no way (yet) of looking up an item by
			//  it's itemId in the gridx table's model to get the row...we can't support this now
			console.log("ERROR: setSelectedObjectIds not supported yet for GRIDX based table");
			grid.selection.clear();
				
			// Deal with items
			if (itemIds) {
				var length = itemIds.length;
				for (var i = 0; i < length; i++) {
					var item = ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.getItemByAbsoluteId(this._dataset, itemIds[i]);
					var idx = grid.getItemIndex(item);
					if (idx >= 0) {
						grid.selection.addToSelection(idx);
					}
				}
			}					
		}
			
		//Call superclass
		this.inherited(arguments);
			
		//Mark we're done changing
		this._changing = false;
	},

	setSelectedObjects: function(/*ibm.tivoli.navmodel.Item[]*/items, /*ibm.tivoli.navmodel.Link[]*/links, /*ibm.tivoli.navmodel.Relationship[]*/relationships, /*Integer[]*/rowIds) {		
		// Mark we're changing
		this._changing = true;
			
		if (!this._ignore) {			
			// Clear selection
			var grid = this._pluggableView._table._grid;
			
			// grid.select.row.clear();    remove for now...no longer needed?
				
			// Deal with items
            if (items && items.length > 0 && rowIds && rowIds.length > 0) {
                dojo.forEach(rowIds, function(rowId) { 
                      grid.select.row.selectById(rowId);
                   });
            }
            // need else case for calling in programmatically with only items
            // but that will require lookup from item to row in gridx
            grid.model.when();   // Necessary?  Check with gridx developers					
		}
		
    	//Call superclass
		this.inherited(arguments);
			
		//Mark we're done changing
		this._changing = false;		
	},
    
	updateSelectedObjects: function(/*ibm.tivoli.navmodel.Item[]*/items, /*Integer[]*/rowIds) {	
		this._ignore = true;
   		this.setSelectedObjects(items, null, null, rowIds);
   		this._ignore = false;
   	}	
});
});
