/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/menus/Menu", [
	"require",
	"dojo/_base/kernel",
	"dojo/_base/declare",
	"dijit/_WidgetBase",
	"dojo/_base/lang",
	"idx/oneui/MenuBar",
	"ibm/usmi/statuspod/AlertStatusPod",
	"ibm/usmi/statuspod/JobStatusPod"
], function (require, dojo, declare, WidgetBase, lang, MenuBar, AlertStatusPod,
		JobStatusPod) {
	return declare([
		WidgetBase,
		MenuBar
	], {

		showProblemStatusPod : false,

		showJobStatusPod : false,

		baseClass : "menus.Menu",

		constructor : function (args) {
			dojo.safeMixin(this, args);

		},

		postCreate : function () {
			this.inherited(arguments);
			if (this.showProblemStatusPod) {
				var problemMenuBarItem = new AlertStatusPod({
					id : "alertStatusPod"
				});
				this.addChild(problemMenuBarItem);
			}
			if (this.showJobStatusPod) {
				var jobMenuBarItem = new JobStatusPod({
					id : "jobStatusPod"
				});
				this.addChild(jobMenuBarItem);
			}
		}
	});
});
