/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
/*global define */
define("ibm/usmi/scheduler/wizard_pages/nls/en/JobLaunchWizardResources", {
	/**
	 * This file contains resources for each page of the job launch wizard.
	 * Please keep overall Job Launch Wizard resources in the first section of
	 * the file. The second section contains resources for the Schedule page.
	 * The third section contains resources for the Notifications page. The
	 * fourth section contains resources for the Options page.
	 */

	/**
	 * Section 1: Overall Job Launch Wizard resources.
	 */
	// Messages:
	JOB_SUCCESSFULLY_RUN_NOW : "The following job has been created and started successfully:  ",
	JOB_SUCCESSFULLY_SCHEDULED : "The following job has been created and scheduled successfully:  ",
	JOB_CREATION_FAILED : "The creation of the new job has failed.",
	JOB_FAILED_RESPONSE : "If problem persists, contact Support.",
	// The following error message should never be displayed to the user.  There 
	// are no scenarios where this message should ever needed
	// However, if a bug exists in the code, this message can be used so that
	// the UI does not crash (and give no reason to the user why the UI did not function
	// as expected).  Currently logging is not defined...When logging is defined and working, 
	// the code is obligated to log additional information (when available) before issuing
	// this message.
	GENERIC_ERROR_MESSAGE : "A problem occurred trying to launch the task.",
	GENERIC_ERROR_RESPONSE : "If the problem persists, contact your next level of support or your service representative.",
	
	// Field labels:
	SUBMIT_BUTTON_LABEL : "Submit",
			
	// Completion Message link text
	VIEW_JOB_LINK_TEXT : "View Job",

	/**
	 * Section 2: Resources for the Schedule Page of the Job Launch Wizard.
	 */
	// Page title:
	SCHEDULE_PAGE_TITLE : "Schedule",

	// Messages:
	NO_VALID_JOB_NAME_ERROR : "The value entered for the job name is not valid.",
	MISSING_CUSTOM_DATES : "No custom dates have been selected.",
	SELECTED_DATE_IN_PAST : "The currently selected date and time is either in the past or right now.",
	REPEAT_FOR_DURATION_NOT_VALID : "Choose a Repeat For duration value between 1 and 5000.",
	REPEAT_UNTIL_DURATION_NOT_VALID : "The Repeat Until duration value is before the scheduled date.",
	MISSING_SELECTED_DAY_OF_WEEK : "No days of the week have been selected.",
	MISSING_MONTHLY_DATES : "No monthly dates have been selected.",
	CUSTOM_DATE_ALREADY_SELECTED : "The custom date selected is already in the list.  Select a different date.",
	CUSTOM_DATE_IN_PAST : "The custom date selected is either in the past or right now.  Select a different date.",
	MONTHLY_DATE_ALREADY_SELECTED : "The monthly date selected is already in the list.  Select a different date.",

	// Field labels:
	WHEN_TO_RUN_LABEL : "When to run:",
	JOB_NAME_LABEL : "Job Name:",
	SCHEDULE_DATE_LABEL : "Date:",
	SCHEDULE_TIME_LABEL : "Time:",
	REPEATE_OPTIONS_LABEL : "Repeat Options:",
	FREQUENCY_LABEL : "Frequency:",
	WEEKEND_LABEL : "On Weekends:",
	WEEKLY_VALUES_LABEL : "Run every week on the following days:",
	MONTHLY_SELECT_LABEL : "Run every month on the following days:",
	CUSTOM_DATES_ADD_VALUES_PROMPT : "Click Add to add the above date to the list of scheduled dates below.",
	DURATION_LABEL : "Duration:",
	REPEAT_OPTIONS_LABEL : "Repeat Options:",
	REPEAT_FOR_VALUE_LABEL : "Repeat For:",
	REPEAT_UNTIL_VALUE_LABEL : "Repeat Until:",
	REPEAT_FOREVER_PROMPT : "Unlimited",
	REPEAT_FOR_PROMPT : "For",
	REPEAT_UNTIL_PROMPT : "Until",
	ADD_BUTTON_LABEL : "Add",
	REMOVE_BUTTON_LABEL : "Remove",

	// Field values:
	RUN_NOW_VALUE : "Run Now",
	RUN_LATER_VALUE : "Schedule",
	REPEAT_FOREVER_VALUE : "Repeat Forever",
	REPEAT_SELECTION_ONCE_VALUE : "Once",
	REPEAT_SELECTION_HOURLY_VALUE : "Hourly",
	REPEAT_SELECTION_DAILY_VALUE : "Daily",
	REPEAT_SELECTION_WEEKLY_VALUE : "Weekly",
	REPEAT_SELECTION_MONTHLY_VALUE : "Monthly",
	REPEAT_SELECTION_YEARLY_VALUE : "Yearly",
	REPEAT_SELECTION_CUSTOM_VALUE : "Custom",
	WEEKEND_DONT_MOVE_VALUE : "Don't move",
	WEEKEND_MOVE_TO_FRIDAY_VALUE : "Move to Friday",
	WEEKEND_MOVE_TO_MONDAY_VALUE : "Move to Monday",
	WEEKEND_MOVE_TO_WEEKDAY_VALUE : "Move to nearest weekday",
	WEEKEND_DELETE_VALUE : "Delete",
	WEEKLY_SUNDAY_VALUE : "Sunday",
	WEEKLY_MONDAY_VALUE : "Monday",
	WEEKLY_TUESDAY_VALUE : "Tuesday",
	WEEKLY_WEDNESDAY_VALUE : "Wednesday",
	WEEKLY_THURSDAY_VALUE : "Thursday",
	WEEKLY_FRIDAY_VALUE : "Friday",
	WEEKLY_SATURDAY_VALUE : "Saturday",

	MONTHLY_DATE_1ST_VALUE : "1st",
	MONTHLY_DATE_2ND_VALUE : "2nd",
	MONTHLY_DATE_3RD_VALUE : "3rd",
	MONTHLY_DATE_4TH_VALUE : "4th",
	MONTHLY_DATE_5TH_VALUE : "5th",
	MONTHLY_DATE_6TH_VALUE : "6th",
	MONTHLY_DATE_7TH_VALUE : "7th",
	MONTHLY_DATE_8TH_VALUE : "8th",
	MONTHLY_DATE_9TH_VALUE : "9th",
	MONTHLY_DATE_10TH_VALUE : "10th",
	MONTHLY_DATE_11TH_VALUE : "11th",
	MONTHLY_DATE_12TH_VALUE : "12th",
	MONTHLY_DATE_13TH_VALUE : "13th",
	MONTHLY_DATE_14TH_VALUE : "14th",
	MONTHLY_DATE_15TH_VALUE : "15th",
	MONTHLY_DATE_16TH_VALUE : "16th",
	MONTHLY_DATE_17TH_VALUE : "17th",
	MONTHLY_DATE_18TH_VALUE : "18th",
	MONTHLY_DATE_19TH_VALUE : "19th",
	MONTHLY_DATE_20TH_VALUE : "20th",
	MONTHLY_DATE_21ST_VALUE : "21st",
	MONTHLY_DATE_22ND_VALUE : "22nd",
	MONTHLY_DATE_23RD_VALUE : "23rd",
	MONTHLY_DATE_24TH_VALUE : "24th",
	MONTHLY_DATE_25TH_VALUE : "25th",
	MONTHLY_DATE_26TH_VALUE : "26th",
	MONTHLY_DATE_27TH_VALUE : "27th",
	MONTHLY_DATE_28TH_VALUE : "28th",
	MONTHLY_DATE_29TH_VALUE : "29th",
	MONTHLY_DATE_30TH_VALUE : "30th",
	MONTHLY_DATE_31ST_VALUE : "31st",

	REPEAT_FOR_HOURS_VALUE : "Hours",
	REPEAT_FOR_DAYS_VALUE : "Days",
	REPEAT_FOR_WEEKS_VALUE : "Weeks",
	REPEAT_FOR_MONTHS_VALUE : "Months",
	REPEAT_FOR_YEARS_VALUE : "Years",

	/**
	 * Section 3: Resources for the Notifications Page of the Job Launch Wizard.
	 */
	// Page title:
	NOTIFICATIONS_PAGE_TITLE : "Notifications",

	// Messages:
	PERCENT_FAILED_VALUE_NOT_SET_ERROR : "Choose a percentage of targets failed that is between 1 and 100.",
	NUMBER_FAILED_VALUE_NOT_SET_ERROR : "Choose a number of targets failed that is greater than 0.",
	MISSING_EMAIL_INFORMATION : "Ensure information has been entered for all e-mail fields.",
	EMAIL_ADDRESS_WRONG_FORMAT : "E-mail address has wrong format",

	// Field labels:
	RECEIVE_NOTIFICATIONS_LABEL : "Receive Notifications:",
	JOB_FAILS_ANY_ERROR_RADIO_LABEL : "Any Error",
	JOB_FAILS_PERCENT_ERROR_RADIO_LABEL : "Percentage targets with errors:",
	JOB_FAILS_NUMBER_ERROR_RADIO_LABEL : "Number targets with errors:",
	EMAIL_INFORMATION_LABEL : "E-mail information:",
	EMAIL_ADDRESS_LABEL : "E-mail address:",
	EMAIL_SERVER_LABEL : "E-mail server name:",
	EMAIL_PORT_LABEL : "E-mail server port number:",

	// Field values:
	JOB_BEGINS_VALUE : "Notify when this job begins.",
	JOB_COMPLETES_OK_VALUE : "Notify when this job is completed successfully.",
	JOB_FAILS_VALUE : "Notify when this job fails.",

	/**
	 * Section 4: Resources for the Notifications Page of the Job Launch Wizard.
	 */
	// Page title:
	OPTIONS_PAGE_TITLE : "Options",

	// Messages:
	MAXIMUM_JOB_INSTANCES_VALUE_ERROR : "Chose a maximum number of job instances between 10 and 100.",

	// Field labels:
	SYSTEM_TIMES_LABEL : "System Times:",
	UNAVAILABLE_SYSTEMS_LABEL : "Unavailable Systems:",
	MAXIMUM_JOBS_LABEL : "Maximum Job Instances:",
	MANAGEMENT_SERVER_TIME_RADIO : "Use the	management server time",
	LOCAL_SYSTEM_TIME_RADIO : "Use local system time",
	FAIL_IF_UNAVAILABLE_RADIO : "Fail if the system is not available",
	RUN_WHEN_AVAILABLE_RADIO : "Run when the system becomes available"
});
