require({cache:{
'url:ibm/usmi/statuspod/templates/alertStatusTip.html':"<div data-dojo-attach-point=\"tipContent\" class=\"statusPodTip\">\r\n<!--\r\n\r\nLicensed Materials - Property of IBM\r\n\r\n(C) Copyright IBM Corp. 2012 All Rights Reserved\r\n\r\nUS Government Users Restricted Rights - Use, duplicate or\r\ndisclosure restricted by GSA ADP Schedule Contract with\r\nIBM Corp.\r\n\r\n-->\r\n</div>",
'url:ibm/usmi/statuspod/templates/alertStatusTipTableRow.html':"<!--\r\n\r\nLicensed Materials - Property of IBM\r\n\r\n(C) Copyright IBM Corp. 2012 All Rights Reserved\r\n\r\nUS Government Users Restricted Rights - Use, duplicate or\r\ndisclosure restricted by GSA ADP Schedule Contract with\r\nIBM Corp.\r\n\r\n-->\r\n\t\t<tr>\r\n\t\t\t<td style=\"${padding}\" colspan=\"2\">\r\n\t\t\t\t<img src=\"${alertSev}\"/> \r\n\t\t\t\t<span class=\"statusPodTipAlertText\" >${alertText}\r\n\t\t\t\t</span>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td>\r\n\t\t\t\t<span class=\"statusPodTipAlert\">${StatusTipCategory} ${alertCat}</span>\r\n\t\t\t</td>\r\n\t\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td>\r\n\t\t\t\t<span class=\"statusPodTipAlert\">${StatusTipDate} ${alertDateTime}</span>\r\n\t\t\t</td>\r\n\t\t</tr>"}});
/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/statuspod/AlertStatusTip", [
	"ibm/tivoli/tip/TCTTable",
	"ibm/tivoli/tip/TCTNavModel",
	"dojo/_base/kernel",
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dijit/_WidgetBase",
	"dijit/_TemplatedMixin",
	"dijit/_WidgetsInTemplateMixin",
	"dojo/text!./templates/alertStatusTip.html",
	"dojo/text!./templates/alertStatusTipTableRow.html",
	"dojo/string",
	"dojo/i18n!./nls/statuspodResources",
	"ibm/usmi/util/DataStore",
	"dojo/_base/Deferred",
	'dojo/_base/unload',
	"ibm/usmi/core/utils/Logger",
	"dojo/date/locale",
	"idx/oneui/HoverHelpTooltip"
], function (TCTTable, TCTNavModel, dojo, declare, lang, WidgetBase, TemplatedMixin, WidgetsInTemplateMixin,
		template, rowTemplate, string, MRI, DataStore, Deferred, baseUnload, Logger, locale) {
	return declare([
		WidgetBase,
		TemplatedMixin,
		WidgetsInTemplateMixin
	], {
		templateString : template,

		entityNode : "",
		objectId : null,
		_dataStore : null,
		isProblems : false,

		isClosed : false,

		activeAlertProperties : [
			"DateTime",
			"SetName",
			"CatName",
			"Severity"
		],
		activeAlertsSort : [ {
			attribute : "DateTime",
			descending : true
		}
		],

		_deferred : null,
		
		_logger : new Logger("ibm.usmi.statuspod", "AlertStatusTip"),

		postCreate : function () {
			this.inherited(arguments);
		},

		startup : function () {
			this.inherited(arguments);
		},

		show : function () {
			this.isClosed = false;
			if (!this._dataStore) {
				this.makeDataSet();
			} else {
				this._showStatusDialog();
			}
		},
		_showStatusDialog : function () {
			if (this.isClosed) {
				this._logger.finest("tooltip is closed, not show it", "_showStatusDialog");
				return;
			}
			idx.oneui.showHoverHelpTooltip(this.tipContent.innerHTML, this.entityNode, /*this.defaultPosition*/null, null, null, null, null, false);
		},

		hide : function () {
			idx.oneui.hideHoverHelpTooltip(this.entityNode);
			this.isClosed = true;
		},

		makeDataSet : function () {
			this._dataStore = new DataStore({
				datasetId : "ACTIVE_ALERTS",
				getTasks : false,
				parameters : {
					sourceToken : this.objectId
				},
				initReadyCallback : lang.hitch(this, this.updateAlertsTable)
			}, {
				sort : this.activeAlertsSort,
				defaultProperties : this.activeAlertProperties,
				createEventRouter : false //do not create event router
			});
			baseUnload.addOnUnload(this._dataStore, "destroy");

		},

		updateAlertsTable : function (items) {
			items = items || [];
			var itemIndex, itemsLength = items.length, html = [], first = true;
			var tipSummary = MRI.StatusShowingTipPartial;
			var maxAlertsInTip = 5, candicateItems = [], item, totalItemsCount = 0, candicateItemsCount = 0;

			items.sort(function (s, t) {
				var a = s.getProperty("Severity").getValue().getId();
				var b = t.getProperty("Severity").getValue().getId();
				a = Number(a);
				b = Number(b);
				if (a < b){
					return -1;
				}
				if (a > b){
					return 1;
				}
				return 0;
			});

			html.push("<table>");

			for (itemIndex = 0; itemIndex < itemsLength; ++itemIndex) {
				item = items[itemIndex];
				var severityId = item.getProperty("Severity").getValue().getId();
				if (severityId < 0 || severityId > 3) {
					if (this.isProblems || (severityId !== 5 && severityId !== "5")) {
						continue;
					}
				}
				var complianceEntry = item.getId().indexOf('ComplianceStatus') !== -1;
				if (this.isProblems && complianceEntry) {
					continue;
				} else if (!this.isProblems && !complianceEntry) {
					continue;
				}
				totalItemsCount++;
				if (candicateItemsCount >= maxAlertsInTip) {
					continue;
				} else {
					candicateItems.push(item);
					candicateItemsCount++;
				}
			}

			for (itemIndex = 0; itemIndex < candicateItems.length; ++itemIndex) {
				item = candicateItems[itemIndex];
				var alertSev = item.getProperty("Severity").getValue().getImage();
				var alertText = item.getProperty("SetName").getValue();
				var alertCat = item.getProperty("CatName").getValue();
				var alertDateTime = this._formatDateStr(item.getProperty("DateTime").getValue());
				var padding = "padding-top:10px;";
				if (first) {
					first = false;
					padding = "";
				}
				var row = string.substitute(rowTemplate, {
					alertText : alertText,
					alertCat : alertCat,
					alertDateTime : alertDateTime,
					padding : padding,
					alertSev : alertSev,
					StatusTipCategory : MRI.StatusTipCategory,
					StatusTipDate : MRI.StatusTipDate

				});
				html.push(row);
			}
			html.push("</table>");

			var text = lang.replace(tipSummary, [
				candicateItemsCount,
				totalItemsCount
			]);

			html.push("<hr><span class='statusPodSummary'>" + text + "</span>");
			var result = html.join("");
			this.tipContent.innerHTML = result;
			this._showStatusDialog();
		},

		_formatDateStr : function (dateTime) {
			var formatedStr;
			if (dateTime) {
				formatedStr=locale.format(dateTime, {formatLength: 'short', timePattern: 'HH:mm:ss ZZZZ'});
			}
			//console.debug("shorten date is:" + formatedStr);
			return formatedStr;
		},
		destroy : function () {
			var dataset;
			this.inherited(arguments);
			this.hide();
			if (this._dataStore) {
				dataset=this._dataStore.getDataset();
				if(dataset){
					dataset.destroy();
				}
				this._dataStore = null;
			}
		}

	});
});