/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/statuspod/_StatusPodPopupMixin", [
	"dojo/_base/kernel",
	"dojo/_base/declare",
	"dojo/_base/lang",
	"dojo/_base/array",
	"ibm/usmi/core/utils/Logger"
], function (dojo, declare, lang, array, Logger) {
	return declare(null, {
		menuItems : [],

		_logger : new Logger("ibm.usmi.statuspod", "_StatusPopupMixin"),

		closeDescendants : function () {
			this._logger.finest("close all descendants menu items", "closeDescendants");
			if (!this.menuItems) {
				return;
			}
			array.forEach(this.menuItems, lang.hitch(this, function (menuItem) {
				if (menuItem) {
					this._logger.finest("close menu item", "closeDescendants");
					menuItem.close();
				}
			}));
		},

		addDescendant : function (/*StatusPodMenuItem*/menuItem) {
			this.menuItems.push(menuItem);
		}

	});
});
