/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/tasks/RenameDialogTask", [
    "dijit",
    "dojo",
    "dojox",
    "dijit/_WidgetBase",
    "dijit/_Templated",
    "dijit/Dialog",
    "dijit/form/Button",
    "dojox/data/dom",
    "ibm/tivoli/navmodel/Trace",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/on",
    "dojo/topic",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/_base/window",
    "dijit/registry",
    "dijit/layout/ContentPane",
    "dojo/i18n!ibm/usmi/nls/frameworkResources",
    "ibm/usmi/util/DefaultMessageHandler",  
    "ibm/usmi/core/utils/Logger",
    "dojo/i18n!ibm/usmi/nls/defaultTaskResources"
],

function (dijit, dojo, dojox, _WidgetBase, _Templated, _Dialog, _Button, dom, theTrace, declare, lang, on, topic,
        construct, style, win, registry, ContentPane, FrameworkMRI, DefaultMessageHandler, Logger, defaultMRI) {

	//Create our widget!
	return declare("ibm.usmi.tasks.RenameDialogTask", [
	    _WidgetBase,
	    ContentPane
	], {
	    // summary:
	    //		Coming soon
	    // description:
	    //		Coming soon

	    //***************************
	    // "Public"
	    //***************************	

	    //*************************** 
	    // "Private"
	    //***************************	

	    //TODO: Formatting is need on all functions!!!!

	    // _trace: [private] ibm.tivoli.navmodel.Trace
	    //		Utility for trace and logging

	    // _dialogDijit: [private]
	    //		Coming soon
	    // _dialogDijit : null,
	    _launchParms : null,
	    _menuItem : null,
	    _context : null,
	    _task : null,
	    _args : null,
	    _selectionName : null,
	    _trace : new theTrace("ibm.usmi.tasks.RenameDialogTask"),
	    FrameworkResources : FrameworkMRI,
	    DefaultResources : defaultMRI,	    
	    // Logger
	    RenameDialogTask : new Logger("ibm.usmi.tasks.RenameDialogTask", "RenameDialogTask"),

	    constructor : function (/*constructor_kwArgs*/kwArgs) {
		    // summary:
		    //		Coming soon
		    // description:
		    //		Coming soon
		    this._args = {
		        launchParms : "",
		        menuItem : "",
		        context : ""
		    };
		    //set title
		    this.title = this.DefaultResources.RENAME;
		    // Register for a DialogTask event

		    lang.mixin(this._args, kwArgs);
		    // Run any parent postCreate processes - can be done at any point
		    this.inherited(arguments);

	    },

	    startup : function () {
		    // summary:
		    //      Coming soon
		    // description:
		    //      Coming soon
		    this.inherited(arguments);
	    },

	    postCreate : function () {
		    // summary:
		    //      Coming soon
		    // description:
		    //      Coming soon
		    var getTasksError = function (error, request) {
			    this._navWidget.hideBusyPane();

			    //Give the user some feedback
			    this.displayException(error);
		    };

		    this.getDataSet().getTasks({
		        onComplete : lang.hitch(this, this._getTasksComplete),
		        onError : lang.hitch(this, getTasksError),
		        taskCategory : "menu", //TODO: Could I specifically request nav hints instead of all tasks?
		        selection : this.getSelection()
		    });

		    // Run any parent postCreate processes - can be done at any point
		    this.inherited(arguments);
		    this._initialize();	    

	    },

	    _initialize : function () {
		    // Get a DOM node reference for the root of our widget
		    var domNode = this.domNode;
		    var selections = this._args.context.selection.getItems();
		    var selectionName = selections[0].getLabel();
		    this._selectionName = selectionName;

		    if (!(this._args.launchParms.confirmationText)) {
			    this._args.launchParms.confirmationText = dojo.string.substitute(this.DefaultResources.TYPE_NAME_MSG, [
			        1,
			        this._selectionName
			    ]);
		    }
		    

		    // text div     
		    var dialogContentDiv = construct.create("div", {
		        id : this.id + "_ConfirmText",
		        "innerHTML" : this._args.launchParms.confirmationText,
		        style : "padding: 5px"
		    });

		    construct.place(dialogContentDiv, domNode);

		    var middleDiv = construct.create("div");
		    style.set(middleDiv, "padding", "5px 5px 5px 10px");

		    construct.place(middleDiv, domNode);
		    
		    var _textNode = win.doc.createTextNode(defaultMRI.DISPLAYNAME);
		    middleDiv.appendChild(_textNode);
		    
		    var renameTextBox = new dijit.form.TextBox({
		        id : this.id + "_DisplayName",
		        name : "_DisplayName"
		    }, middleDiv.appendChild(construct.create("div")));
		    
		    var bottomButtonsDiv = construct.create("div");
		    style.set(bottomButtonsDiv, "padding", "5px 5px 5px 10px");
		    construct.place(bottomButtonsDiv, domNode, "last");

		    var saveButton = new _Button({
		        id : this.id + "_DialogOKButton",
		        label : this.FrameworkResources.OK
		    }, bottomButtonsDiv.appendChild(construct.create("div")));

		    var cancelButton = new _Button({
		        id : this.id + "_DialogCancelButton",
		        label : this.FrameworkResources.CANCEL
		    }, bottomButtonsDiv.appendChild(construct.create("div")));
		    
		    
		    on(saveButton, "click", lang.hitch(this, "onOK"));
		    on(cancelButton, "click", lang.hitch(this, "onCancel"));
	    },

	    // get task from id
	    _getTasksComplete : function (tasks) {

		    //Want to loop through tasks looking for
			var i;
		    if (tasks) {
			    for (i = 0; i < tasks.length; i++) {
				    var task = tasks[i];
				    // found are task.
				    var tid = task.getId();
				    var myid = this.getTaskId();
				    if (task.getId() === this.getTaskId()) {

					    this.setTask(task);

					    break;
				    } else if (task.getChildTasks()) {
					    var subTasks = task.getChildTasks();
					    if (subTasks.length > 0) {
						    this._getTasksComplete(subTasks);
						    if (this.getTask()) {
							    break;
						    }
					    }
				    }
			    }
		    }
	    },

	    destroy : function () {
		    // summary:
		    //		Coming soon
		    // description:
		    //		Coming soon
		    var buttonId = this.id + "_DialogCancelButton";
		    if (registry.byId(buttonId)) {
			    var widgets = dijit.findWidgets(this);
			    dojo.forEach(widgets, function (w) {
				    w.destroyRecursive(true);
			    });
			    registry.byId(this.id).destroyRecursive();

		    }
	    },

	    systemNameChanged : function () {
		    if (registry.byId(this.id + "_DisplayName").value == "") {
			    registry.byId(this.id + "_DialogOKButton").setAttribute('disabled', true);
			    return;
		    }
		    if (registry.byId(this.id + "_DisplayName").value == this._selectionName) {
			    registry.byId(this.id + "_DialogOKButton").setAttribute('disabled', true);
			    return;
		    }
		    registry.byId(this.id + "_DialogOKButton").setAttribute('disabled', false);

	    },

	    //override the onCancel method to also destroy the whole widget.
	    _close : function () {
		    // summary:
		    //		Coming soon
		    // description:
		    //		Coming soon
		    //setTimeout('registry.byId(\"' + this.id + '\").destroyRecursive();',200); 
		    //registry.byId(this.id).destroyRecursive();
		    this.inherited(arguments);
	    },

	    //override the onCancel method to also destroy the whole widget.
	    onCancel : function () {
		    // summary:
		    //		Coming soon
		    // description:
		    //		Coming soon
		    setTimeout('dijit.byId(\"' + this.id + '\").destroyRecursive();', 200);

		    // the above line was not deleting the button id and so additional step

		    this.destroy();
		    topic.publish("DefaultDialogDismissal", []);
		    this.inherited(arguments);
	    },

	    //override the onCancel method to also destroy the whole widget.
	    onOK : function () {
		    // summary:
		    //		Coming soon
		    // description:
		    //		Coming soon

		    var isDuplicate = function (kwArgs) {

			    //var args = {this: null};
			    // args.this = kwArgs;
			    var isDup = false;
			    var selectedItemId = kwArgs._args.context.selection.getItemIds()[0];
			    var queryString = "DisplayName == '" + registry.byId(kwArgs.id + "_DisplayName").value + "'";
			    var queryParms = {
			        queryString : queryString,
			        itemId : selectedItemId
			    };
			    var checkForDuplicate = function (items) {
				    if (items && items.length > 0) {
					    isDup = true;
				    }
			    };

			    var queryItemsError = function (error, exception, ioArgs) {
				    //There was a problem getting the tasks from the dataset
				    var msgHandler = new ibm.tivoli.tip.navwidget.dijit.DefaultMessageHandler({});
				    msgHandler.displayException(error);
			    };

			    // Check for a duplicate name                    
			    kwArgs.getDataSet().queryItems({
			        onComplete : checkForDuplicate,
			        onError : queryItemsError,
			        query : queryParms,
			        sync : true
			    });

			    return isDup;
		    };

		    if (registry.byId(this.id + "_DisplayName").value == "") {
			    registry.byId(this.id + "_DialogOKButton").setAttribute('disabled', true);
			    this._displayMessage("ATKCMT001I", "Error", this.DefaultResources.BLANK_NAME_MSG);
			    return;
		    }

		    if (registry.byId(this.id + "_DisplayName").value == this._selectionName) {
			    registry.byId(this.id + "_DialogOKButton").setAttribute('disabled', true);
			    this._displayMessage("ATKCMT002I", "Error", dojo.string.substitute(
			            this.DefaultResources.ALREADY_NAME_MSG, [
			                1,
			                this._selectionName
			            ]));
			    return;
		    }

		    if (isDuplicate(this)) {
			    var displayName = "'" + registry.byId(this.id + "_DisplayName").value + "'";
			    this._displayMessage("ATKCMT001I", "Error", dojo.string.substitute(
			            this.DefaultResources.NAME_EXIST_MSG, [
			                1,
			                displayName
			            ]));
			    return;
		    }

		    var taskParms = {
			    DisplayName : registry.byId(this.id + "_DisplayName").value
		    };

		    this._task.execute({
		        onError : lang.hitch(this, this._handleExecuteOnServerError),
		        onComplete : lang.hitch(this, this._getExecuteComplete),
		        selection : this.getSelection(),
		        selectionParms : taskParms,
		        sync : true
		    });

		    this.destroy();
		    topic.publish("DefaultDialogDismissal", []);
		    this.inherited(arguments);
	    },

	    //		*********NEED TO UPDATE  

	    getDataSet : function () {
		    return this._args.context.dataset;
	    },

	    getTaskId : function () {
		    return this._args.menuItem.actionID;
	    },

	    getTask : function () {
		    return this._task;
	    },

	    setTask : function (t) {
		    this._task = t;
	    },

	    getId : function () {
		    return this.id;
	    },

	    getSelection : function () {
		    var selectedThings = this._args.context.selection;
		    var currentSelection = null;
		    if (selectedThings) {
			    currentSelection = new ibm.tivoli.navmodel.Selection({
				    version : this.getDataSet().getVersion()
			    }); //context.dataset.getVersion()}); 
			    currentSelection.addItems(selectedThings.getItemIds());
			    currentSelection.addLinks(selectedThings.getLinkIds());
			    currentSelection.addRelationships(selectedThings.getRelationshipIds());
		    }
		    return currentSelection;
	    },

	    getBodyHeight : function () {
		    divHeight = 0.2 * ((window.innerHeight !== undefined) ? window.innerHeight : document.body.offsetHeight);
		    return divHeight < 110 || divHeight > 120 ? 110 : divHeight;
	    },

	    _getExecuteComplete : function (
				result, arg) {
				var r = result;
				var a = arg;
				var moduleName = "_getExecuteComplete";
				// TODO:  Consider how to add a link to the job details in the message -- based on the job ID....r.JobId
				var theMessageTitle = "";
				var msgDesc = "" ;
				// Close the dialog...
				this.onCancel();

				// Display the message...
				var msgHandler = new DefaultMessageHandler();
				var msgId = ""; // not specifying a message ID
				var msgSeverity = DefaultMessageHandler.SUCCESS;
				

				// Note that currently, this method on msgHandler can take a list of targets and prepends them with 
				// "&sourceToken=" -- this doesn't work for launching into
				// the jobs properties -- it needs &DCMJobId=xxxx...so I'll manually build my own URL.
				// msgHandler.displayMessageWithLaunchInContext(msgId, msgSeverity, theMessageTitle, null, null, null, url, this.persistResources.VIEW_JOB_LINK_TEXT, false);

				// build the URL for the link to launch the job properties:
				// TODO:  Is it okay to launch without the task area and nav area -- and to hide the banner/taskbar area?
				var url = window.location.protocol +
					'//' +
					location.host +
					'/ibm/console/xLaunch.do?pageID=com.ibm.usmi.console.scheduler.navigationElement&hideTaskArea=true&disableNavArea=true&hideBannerArea=true&hideTaskBarArea=true';
				url = url + '&DCMJobId=' + r.JobId;

//				msgHandler.displayMessageWithLaunchInContext(
//					msgId, msgSeverity, theMessageTitle, null, null, null, url,
//				this is the launch label", false);
				
		    // Not implemented yet from the server side.  The server needs to send the successful message
			//	msgHandler.displayMessage(msgId, msgSeverity, theMessageTitle, msgDesc, true);
			},
			
	    _handleExecuteOnServerError : function (error, exception, ioArgs) {
	    	var err = error;
			var exc = exception;
			var a = ioArgs;
			
			var moduleName = "_handleExecuteOnServerError";				
		    var theMessageTitle = exc.getMsgText();//exc.getMsgDescription();
			var msgDesc = ""  ;

			// Display the message...as a popup
			var msgHandler = new DefaultMessageHandler();
			var msgId = "";//exc.getMsgId();
			var msgSeverity = DefaultMessageHandler.ERROR;
			this.onCancel();
			msgHandler.displayMessage(msgId, msgSeverity, theMessageTitle, msgDesc, true);
	    },

	    _getBodyHeight : function () {
		    return ((window.innerHeight !== undefined) ? window.innerHeight : document.body.offsetHeight);
	    },

	    _displayMessage : function (/*Object*/msgId, /*Object*/msgSeverity, /*Object*/msgText) {
		    // summary:
		    //		Coming soon
		    // description:
		    //		Coming soon

		    this.onCancel();
		    var msgDlg = new dojoe.messagedialog.MessageDialog({
		        message : msgText,
		        messageId : msgId,
		        type : msgSeverity
		    });
		    msgDlg.show();
	    }

	});

});
