/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/tasks/ServiceSupportDialogTask", ["dijit",
        "dojo",
        "dojox",
        "dijit/_WidgetBase",
        "dijit/_Templated",
        "dijit/Dialog", 
        "dijit/form/Button",
        "dojox/data/dom",
        "ibm/tivoli/navmodel/Trace",
        "dojo/_base/declare",
        "dojo/_base/lang",
        "dojo/on",
        "dojo/topic",
        "dojo/dom-construct",
        "dojo/dom-style",
        "dojo/_base/window",
        "dijit/registry",
        "ibm/usmi/util/DefaultMessageHandler",
        "dijit/layout/ContentPane"], 
     
        function(dijit,dojo,dojox,_WidgetBase, _Templated,_Dialog,_Button,dom,theTrace,declare,lang,on,topic,construct,style,win,registry, DefaultMessageHandler, ContentPane){  

	//Create our widget!
	return declare("ServiceSupportDialogTask",[_WidgetBase,ContentPane], {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon

		//***************************
		// "Public"
		//***************************	

		//*************************** 
		// "Private"
		//***************************	

		//TODO: Formatting is need on all functions!!!!

		// _trace: [private] ibm.tivoli.navmodel.Trace
		//		Utility for trace and logging

		// _dialogDijit: [private]
		//		Coming soon
		// _dialogDijit : null,		
		_task: null,
		_args: null,
		_selectionName: null,
		_trace : new theTrace("ServiceSupportDialogTask"),
        taskparms : null,
        properties : null,
		
		constructor : function(/*constructor_kwArgs*/ kwArgs) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			this._args = {
					launchParms: "",
					menuItem: "",
					context: ""
			};
			//set title
			this.title = "Service And Support Manager"; // TODO - get from MRI bundle
			// Register for a DialogTask event

			lang.mixin(this._args, kwArgs);
			// Run any parent postCreate processes - can be done at any point
			this.inherited(arguments);

		},

		startup : function() {
			// summary:
			//      Coming soon
			// description:
			//      Coming soon

			this.inherited(arguments);
		},

		postCreate : function() {
			// summary:
			//      Coming soon
			// description:
			//      Coming soon

			var getTasksError = function(error, request){
				this._navWidget.hideBusyPane();

				//Give the user some feedback
				this.displayException(error);
			};


			this.getDataSet().getTasks({
				onComplete: lang.hitch(this, this._getTasksComplete),
				onError: lang.hitch(this, getTasksError),
				taskCategory: "menu", //TODO: Could I specifically request nav hints instead of all tasks?
				selection: this.getSelection()});

		

			// Run any parent postCreate processes - can be done at any point
			this.inherited(arguments);
            this._initialize();


		},

		_initialize: function() {
			// Get a DOM node reference for the root of our widget
			var domNode = this.domNode;
			var selections = this._args.context.selection.getItems();
			var selectionName = selections[0].getLabel();
			this._selectionName = selectionName;

			if (!(this._args.launchParms.confirmationText)) {
				this._args.launchParms.confirmationText = "Submitting a service request notifies the service provider, and you may be contacted to provide additional information to resolve the problem."  //TODO get from MRI bundle
			}

			// text div     
			var dialogContentDiv = construct.create("div",{
				id: this.id+"_ConfirmText",
				"innerHTML": this._args.launchParms.confirmationText,
				style: "padding: 5px"
			});
			construct.place(dialogContentDiv,domNode);

			var shortDiscriptionDiv = construct.create("div");
			style.set(shortDiscriptionDiv, "borderTopWidth", "1px");
			style.set(shortDiscriptionDiv, "padding", "5px 5px 5px 10px");
			construct.place(shortDiscriptionDiv, domNode);
			
			var _textNode = win.doc.createTextNode("*Problem Description (100 character limit):") ;
			//_textNode.id = this.id+"_textNode";
			shortDiscriptionDiv.appendChild(_textNode);
			
			var shortDescripTextBoxDiv = construct.create("div");
			style.set(shortDescripTextBoxDiv, "padding", "5px 5px 5px 10px");
			
			
			var shortTextBox = new dijit.form.ValidationTextBox({
				id: this.id+"_shortTextBox",
				name: "_shortTextBox",
				required: "true",
				promptMessage:"Please provide a short description of the error.",
				maxLength: "100"
			},shortDescripTextBoxDiv.appendChild(construct.create("div"))); 
			style.set(shortTextBox.domNode, "width", "800px"); 
			construct.place(shortDescripTextBoxDiv, domNode);
			
			/*********************************************************************************/
			var longDiscriptionDiv = construct.create("div");
			style.set(longDiscriptionDiv, "padding", "5px 5px 5px 10px");
			construct.place(longDiscriptionDiv, domNode);
			
			var _longtextNode = win.doc.createTextNode("*Problem details (500 character limit):") ;
			//_longtextNode.id = this.id+"_longtextNode";
			longDiscriptionDiv.appendChild(_longtextNode);
			
			var longDescripTextBoxDiv = construct.create("div");
			style.set(longDescripTextBoxDiv, "padding", "5px 5px 5px 10px");		
			
			var longTextBox = new dijit.form.SimpleTextarea({
				id: this.id+"_longTextBox",
				name: "_longTextBox",
				required: "true",
				promptMessage:"Please provide a more detailed description of the problem. This information can not be empty.",
				maxLength: "500",
				rows: "5",
				cols: "100"
			},longDescripTextBoxDiv.appendChild(construct.create("div"))); 
			style.set(longTextBox.domNode, "width", "782px"); 
			style.set(longTextBox.domNode, "height", "50px"); 
			construct.place(longDescripTextBoxDiv, domNode);
			
			var bottomButtonsDiv = construct.create("div");
			style.set(bottomButtonsDiv,"padding","5px 5px 5px 10px");
			construct.place(bottomButtonsDiv,domNode,"last");

			var saveButton = new _Button({
				id: this.id+"_DialogOKButton",
				label:"Submit"
			},bottomButtonsDiv.appendChild(construct.create("div")));

			var cancelButton = new _Button({ 
				id: this.id+"_DialogCancelButton",
				label:"CANCEL"
			},bottomButtonsDiv.appendChild(construct.create("div")));		

			on(saveButton, "click", lang.hitch(this,"onOK"));
			on(cancelButton, "click",lang.hitch(this,"onCancel"));	
		},
		
		// get task from id
		_getTasksComplete: function(tasks) {

			//Want to loop through tasks looking for
			if (tasks) {
				for (var i = 0; i < tasks.length; i++) {
					var task = tasks[i];
					// found are task.
					var tid = task.getId() ;
					var myid = this.getTaskId() ;
					if (task.getId() === this.getTaskId()) {

						this.setTask(task);

						break;
					}
					else if (task.getChildTasks()) {
						var subTasks = task.getChildTasks();
						if (subTasks.length > 0) {
							this._getTasksComplete(subTasks);
							if (this.getTask()) {
								break;
							}
						}
					}
				}
			}
		},


		destroy : function() {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			var buttonId=this.id+"_DialogCancelButton";
			if(registry.byId(buttonId)) {
				var widgets = dijit.findWidgets(this);
				dojo.forEach(widgets, function(w) {
				    w.destroyRecursive(true);
				});
				registry.byId(this.id).destroyRecursive();

			}
			this.inherited(arguments);
		},


		//override the onCancel method to also destroy the whole widget.
		_close : function() {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			//setTimeout('registry.byId(\"' + this.id + '\").destroyRecursive();',200); 
			//registry.byId(this.id).destroyRecursive();
			this.inherited(arguments);
		},
		
		//override the onCancel method to also destroy the whole widget.
		onCancel: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			setTimeout('registry.byId(\"' + this.id + '\").destroyRecursive();',200); 

			// the above line was not deleting the button id and so additional step

			this.destroy();
			topic.publish("DefaultDialogDismissal", []);
			this.inherited(arguments);			
		},

		//override the onCancel method to also destroy the whole widget.
		onOK: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			var lt = registry.byId(this.id+"_longTextBox").value;
			var st = registry.byId(this.id+"_shortTextBox").value;
			if(lt === null || lt === "" || st === null || st ==="") return;
			
			var taskParms = {problemDetails: registry.byId(this.id+"_longTextBox").value,
							 problemDescription: registry.byId(this.id+"_shortTextBox").value};
			this._task.execute({
				onError: lang.hitch(this, this._handleExecuteOnServerError),
				onComplete : lang.hitch(this, this._getExecuteComplete),
				selection: this.getSelection(), 
				selectionParms: taskParms,
				sync: true});
 
			this.destroy();
			topic.publish("DefaultDialogDismissal", []);
			this.inherited(arguments);			
		},


//		*********NEED TO UPDATE  

		onHelp: function(){       

			this.getTask().execute({onError: lang.hitch(this, this._handleExecuteOnServerError),selection: this.getSelection()})
			this.destroy();
			topic.publish("DefaultDialogDismissal", []);
			this.inherited(arguments);          
		},

		getDataSet: function() {
			return this._args.context.dataset;
		},

		getTaskId: function() {
			return this._args.menuItem.actionID;
		},

		getTask: function() {
			return this._task;
		},

		setTask: function (t) {
			this._task = t;
		},

		getId: function() {
			return this.id ;
		},

		getSelection: function() {
			var selectedThings = this._args.context.selection;
			var currentSelection = null;
			if (selectedThings) {
				currentSelection = new ibm.tivoli.navmodel.Selection({version: this.getDataSet().getVersion()}); //context.dataset.getVersion()}); 
				currentSelection.addItems(selectedThings.getItemIds());
				currentSelection.addLinks(selectedThings.getLinkIds());
				currentSelection.addRelationships(selectedThings.getRelationshipIds());
			}
			return currentSelection;
		},

		getBodyHeight: function() {
			divHeight = 0.2 * ((window.innerHeight !== undefined) ? window.innerHeight : document.body.offsetHeight);	     
			return divHeight < 110 || divHeight > 150 ? 150 : divHeight;
		},
		
	    _getExecuteComplete : function (
			result, arg) {
			var r = result;
			var a = arg;
			var moduleName = "_getExecuteComplete";
			// TODO:  Consider how to add a link to the job details in the message -- based on the job ID....r.JobId
			var theMessageTitle = "";
			var msgDesc = "" ;		
	
			// Display the message...
			var msgHandler = new DefaultMessageHandler();
			var msgId = ""; // not specifying a message ID
			var msgSeverity = DefaultMessageHandler.SUCCESS;
            // Server side has not been implemented yet
			//msgHandler.displayMessage(msgId, msgSeverity, theMessageTitle, msgDesc, true);
		},
			
	    _handleExecuteOnServerError : function (error, exception, ioArgs) {
	    	var err = error;
			var exc = exception;
			var a = ioArgs;
			var moduleName = "_handleExecuteOnServerError";
		    var theMessageTitle = this._selectionName 
			var theMessageDesription = exc.getMsgText();
			var msgDesc = theMessageDesription;		
			
			if (this.DefaultConfirmationLogger.error()) {
				this.DefaultConfirmationLogger.error("ServiceSupportDialogTask:  Failed to launch service and support request: ", moduleName);
				this.DefaultConfirmationLogger
					.error("ServiceSupportDialogTask:  The error received is:  " + err, moduleName);
				this.DefaultConfirmationLogger.error("ServiceSupportDialogTask:  The exception is:  " + exc, moduleName);
			}		

			// Display the message...
			var msgHandler = new DefaultMessageHandler();
			var msgId = ""; // not specifying a message ID
			var msgSeverity = DefaultMessageHandler.ERROR;
			msgHandler.displayMessage(msgId, msgSeverity, theMessageDesription, msgDesc, true);
	    },


		_getBodyHeight : function() {
			return ((window.innerHeight !== undefined) ? window.innerHeight : document.body.offsetHeight);
		},

		_displayMessage: function(/*Object*/ msgId, /*Object*/ msgSeverity, /*Object*/ msgText) {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			this.onCancel();						
			var msgDlg = new dojoe.messagedialog.MessageDialog(
					{message: msgText,
						messageId: msgId,
						type: msgSeverity});
			msgDlg.show();
		}


	});

});
