/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */

define("ibm/usmi/util/DefaultDialogTask", [
	"dijit",
	"dijit/_WidgetBase",
	"dijit/Dialog",
	"dijit/form/Button",
	"ibm/tivoli/navmodel/Trace",
	"dojo/_base/declare",
	"dojox/data/dom",
	"dojo/topic",
	"dojo/_base/lang",
	"dijit/registry",
	"dojo/dom-style",
	"dojo/dom-construct",
	"dojo/i18n!ibm/usmi/nls/frameworkResources",
	"dojo/i18n!ibm/usmi/nls/defaultTaskResources",
	"dojo/window",
	"dojo/dom-geometry"
],

function (dijit, _WidgetBase, _Dialog, _Button, _Trace, declare, dom, topic, lang, registry, style, construct,
		frameworkmri, defaultmri, winUtils, domGeometry) {

	//ibm.usmi.util.DefaultDialogTask._trace = new ibm.tivoli.navmodel.Trace("ibm.usmi.util.DefaultDialogTask");

	return declare("ibm.usmi.util.DefaultDialogTask", [
		_WidgetBase,
		_Dialog
	], {
		// summary:
		//		Coming soon
		// description:
		//		Coming soon

		//***************************
		// "Public"
		//***************************	

		//*************************** 
		// "Private"
		//***************************	

		// _trace: [private] ibm.tivoli.navmodel.Trace
		//		Utility for trace and logging
		_trace : new _Trace("ibm.usmi.util.DefaultDialogTask"),

		// _dialogDijit: [private]
		//		Coming soon
		_dialogDijit : null,
		
		_dijitDiv: null,
		
		_dialogDiv: null,

		_subscriptions : [],

		FrameworkResources : frameworkmri,
		DefaultResources : defaultmri,

		constructor : function () {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			//set title
			this.title = this.DefaultResources.DELETE; // TODO - get from MRI bundle

			// Register for a DialogTask event
			var sub = topic.subscribe("DefaultDialogLaunch", lang.hitch(this, this._handleDialogLaunch));
			this._subscriptions.push(sub);
			sub = topic.subscribe("DefaultNoninteractiveTask", lang.hitch(this, this._handleDialogLaunch));
			this._subscriptions.push(sub);
		},

		postCreate : function () {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			//Call superclass
			this.inherited(arguments);

			// Register for a Dialog dismissal event
			var sub = topic.subscribe("DefaultDialogDismissal", lang.hitch(this, this._close));
			this._subscriptions.push(sub);
		},

		startup : function () {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon

			this.inherited(arguments);
		},

		destroy : function () {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			if (this._dialogDijit) {
				this._dialogDijit.destroyRecursive();
			}
			if (this._subscriptions) {
				var i;
				for (i=0; i < this._subscriptions.length; i++) {
					this._subscriptions[i].remove();
				}
				this._subscriptions = null;
			}
			this.inherited(arguments);
		},

		//override the onCancel method to also destroy the whole widget.
		_close : function () {
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			//setTimeout('registry.byId(\"' + this.id + '\").destroyRecursive();',200); 
			dijit.byId(this.id).hide();
			this.inherited(arguments);
		},

	    _handleDialogLaunch : function (launchParms, menuItem, context) {
		    // summary:
		    //		Coming soon
		    // description:
		    //		Coming soon

		    var dialogContentWidget = null, divHeight, diijtHeight;
		    if (launchParms) {
			    // Handle undefined path and dijit, use utils.DefaultConfirmationDialogTask
			    if (!launchParms.modulePath && !launchParms.dijit) {
				    launchParms.modulePath = "ibm.usmi.tasks";
				    launchParms.dijit = "DefaultConfirmationDialogTask";
			    }
			    dialogContentWidget = launchParms.modulePath + "." + launchParms.dijit;
			   
			    if(!this._dijitDiv){
			    	this._dijitDiv = construct.create("div");
				    construct.place(this._dijitDiv, this.containerNode);
			    }
			    
				
			    
			    /*
				//the child dialog widget should implement getBodyHeight() to ensure the correct height
			    divHeight = null;
			    try {
				    divHeight = this._dialogDijit.getBodyHeight();
			    } catch (err) {
				    divHeight = 0.2 * this._getBodyHeight();
			    }
				if (!divHeight) {
					divHeight = 0.8 * this._getBodyHeight();
				}
			    style.set(dijitDiv, "height", divHeight);
			    
			    */

				//this.show();
				
			    // custom builds don't like passing variables into dojo.require
			    // so we have to do a little trick instead - RFB
			    // dojo.require(dialogContentWidget); // RFB
			    dojo["require"](dialogContentWidget);

			    var classname = eval(dialogContentWidget);
			    if (this._dialogDijit) {
				    this._dialogDijit.destroy();
				    this._dialogDijit = null;
			    }
			    if(this._dialogDiv){
			    	construct.destroy(this._dialogDiv);
			    	delete this._dialogDiv;
			    }
			    this._dialogDiv=construct.create("DIV");
			    this._dijitDiv.appendChild(this._dialogDiv);
			    
			    if (!this._dialogDijit) { //create the widget. 
				    this._dialogDijit = new classname({
				        // id causee a TaskID already exist error in Dojo
				        // id : launchParms.dijit + "_DialogContentWidget",
				        launchParms : launchParms,
				        menuItem : menuItem,
				        context : context
				    }, this._dialogDiv);
			    }

				this.show();

				this._dialogDijit.startup();

				
				if (this._dialogDijit.resize) {
					if (dialogContentWidget === "ibm.usmi.scheduler.JobLaunchWizard") {
						var bb = domGeometry.position(this.containerNode);
						diijtHeight=bb.h;
						diijtHeight-=32;
						//diijtHeight-=2; //remove two additional pixels
						this._dialogDijit.resize( {
							w : 700,
							h : diijtHeight
						}); 
					} else {
					this._dialogDijit.resize();
					}					
				}
				
				if (this._dialogDijit.updateUI) {
					// no longer need to call updateUI twice
					// this._dialogDijit.updateUI();
					this._dialogDijit.updateUI();
				}
				this.layout();
				
			    if (launchParms.dialogTitle) {
				    this.attr("title", launchParms.dialogTitle);
			    }

		    } else {
			    alert("undefined launch parms from server task");
			    // TODO log error and put up message?
		    }

	    },

		_getBodyHeight : function () {
			return ((window.innerHeight !== undefined) ? window.innerHeight : document.body.offsetHeight);
		}
	});
});
