// wrapped by build app
define("ibm/usmi/widgets/TaskPane", ["dijit","dojo","dojox","dojo/require!dojo/hash,dijit/_WidgetBase,dijit/_Container,ibm/usmi/util/BaseWidget,ibm/usmi/widgets/TaskLink,ibm/usmi/widgets/TaskCategory,ibm/usmi/widgets/util/Constants"], function(dijit,dojo,dojox){
/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */

/* define(["dojo/_base/kernel",
        "dojo/_base/declare",
        "dijit/_WidgetBase",
        "dijit/_Container",
 //       "dojo/_base/Deferred",
        "dojo/hash",
        // NextGen imports
        "ibm/usmi/widgets/TaskLink",
        "ibm/usmi/widgets/TaskCategory"],
    function (dojo, declare, _WidgetBase, _Container, //Deferred,
            TaskLink, TaskCategory) {

    return declare([_WidgetBase, _Container], {*/

dojo.provide("ibm.usmi.widgets.TaskPane");

dojo.require("dojo.hash");
dojo.require("dijit._WidgetBase");
dojo.require("dijit._Container");
dojo.require("ibm.usmi.util.BaseWidget");
dojo.require("ibm.usmi.widgets.TaskLink");
dojo.require("ibm.usmi.widgets.TaskCategory");
dojo.require("ibm.usmi.widgets.util.Constants");

dojo.declare("ibm.usmi.widgets.TaskPane",[dijit._WidgetBase, dijit._Container, ibm.usmi.util.BaseWidget],
{

	topic : "",
	subject : "",

	_deferredEvent : null,
	_categories : [],
	_links : [],
	_type : "",
	subscription : null,
	tabIndex : "0", // propagate tabIndex to TaskCategorys from declaration or invocation, default to zero

	postCreate : function () {
		this.inherited(arguments);
		this._deferredEvent = new dojo.Deferred();
	},

	startup : function () {
		this.inherited(arguments);
		this._categories = this.getChildren();
		this._links = [];
		var _this = this;
		dojo.forEach(this._categories, function (category) {
			_this._links = _this._links.concat(category.getChildren());
		});

		this.subscription = this.subscribe(ibm.usmi.widgets.util.Constants.TOPIC_HASH_CHANGE,
				this._hashChanged);
	},

	refresh : function () {
		this._categories = this.getChildren();
		this._links = [];
		var _this = this;
		dojo.forEach(this._categories, function (category) {
			_this._links = _this._links.concat(category.getChildren());
		});
	},

	addCategory : function (category) {
		var g;
		if (category instanceof ibm.usmi.widgets.TaskCategory) {
			g = dojo.mixin(category, {
				tabIndex : this.tabIndex
			});
		} else {
			g = new ibm.usmi.widgets.TaskCategory(dojo.mixin(category, {
				tabIndex : this.tabIndex
			}));
		}

		this.addChild(g);
	},

	updateCategories : function (updates, type, typeExt) {
		this._categories = this.getChildren();

		dojo.forEach(this._categories, function (category) {
			var visible = this._categoryContainsDevType(category, type, typeExt), src;

			category.set("visible", visible);
			// If category.category explicitly appears in updates and is not null, then use it,
			// else check whether category.sourceCategory was specified and use this one instead.
			src = updates[category.category];
			if (!src && category.sourceCategory) {
				src = updates[category.sourceCategory];
			}
			category.updateLinks(src);
			if (visible) {
				category.setNoTaskMessage();
			}
		}, this);

		if (this._deferredEvent && updates.general) {
			this._deferredEvent.callback(type);
		}
	},

	_categoryContainsDevType : function (category, type, typeExt) {
		// Allow to specify an extension for the type, e.g.
		// 'BlockOnly', 'FileOnly', 'BlockAndFile', so in the
		// devTypes or excludedDevTypes list you may specify,
		// for example, 'netapp' (meaning netapp in any configuration,
		// or 'netappBlockAndFile' (meaning netapp configured for
		// BlockAndFile data).

		type = type || "";
		var extendedType = type ? type + (typeExt || "") : "";

		if (category.devTypes) {
			return (dojo.indexOf(category.devTypes, type) > -1)
					|| (dojo.indexOf(category.devTypes, extendedType) > -1);
		}

		if (category.excludedDevTypes) {
			return (dojo.indexOf(category.excludedDevTypes, type) === -1)
					&& (dojo.indexOf(category.excludedDevTypes, extendedType) === -1);
		}

		return true;
	},

	setLink : function (/*ibm.usmi.widgets.TaskLink*/link) {
		if (link.getParent().get("visible")) {
			dojo.forEach(this._links, function (item) {
				item.select(false);
			});
			link.select(true);
		}
	},

	_hashChanged : function (/*dojo.hash*/hash) {
		dojo.forEach(this._links, function (link) {
			// if criteria exists, trying to render a related resource view, compare task id versus
			// hash releationship
			if (link.criteriaString) {
				if (this.getUrlHashParm(ibm.usmi.widgets.util.Constants.HASH_TASK_RELATIONSHIP) === link.taskId) {
					this._linkClicked(null, link);
				}
			}
			// if not no criteria string, compare task id versus hash task selection parm
			else {
				if (this.getUrlHashParm(ibm.usmi.widgets.util.Constants.HASH_TASK_SELECTION) === link.taskId) {
					this._linkClicked(null, link);
				}
			}
		}, this);
	},

	_linkClicked : function (event, link) {
		this.setLink(link);

		var category = link.getParent(), args = [
			category,
			link,
			this.subject
		],
		// the following publish should be deferred to "update" completed
		_this = this;

		if (this._deferredEvent) {
			this._deferredEvent.addCallback(function (extraInfo) {
				dojo.publish(_this.topic, (extraInfo ? args.concat([ extraInfo
				]) : args));
				_this._type = extraInfo ? extraInfo : "";
				// do not need to defer next time
				delete _this._deferredEvent;
			});
		} else {
			dojo.publish(this.topic, this._type ? args.concat([ this._type
			]) : args);
		}
		dojo.publish(this.topic + "/" + this.subject, args);

		// publish the label, so workarea can render title
		dojo.publish(ibm.usmi.widgets.util.Constants.TOPIC_TASK_TITLE_CHANGE, {
			resource : link.getResourceLabel(),
			view : link.getLabel(),
			loading : false
		});
		
		// if this was kicked off by a link selection, must have been a bookmark or direct call,
		// need to kick off retarget event
		if(!link.getWasClicked()) {
			link.fakeClick();
		}
		
		// reset variable
		link.resetWasClicked();
	},

	selectTask : function (/*String*/taskName) {
		var link, idx = 0;
		while ((idx < this._links.length)) {
			if (this._links[idx].link === taskName) {
				link = this._links[idx];
				break;
			}
		}
		if (link) {
			this._linkClicked(null, link);
		}
	},

	getCategory : function (/*String*/category) {
		var subset = dojo.filter(this.getChildren(), function (/*Widget*/child) {
			return child.isInstanceOf(ibm.usmi.widgets.TaskCategory) && child.category === category;
		}, this);
		return (subset && subset[0]) || null;
	},
	destroy : function () {
		if (this.subscription) {
			this.subscription.remove();
			this.subscription = null;
		}
		this.inherited(arguments);
	}
});
});
