/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
//Finder GroupDataStore
define("ibm/usmi/widgets/finder/GroupDataStore", [
	"dojo/_base/lang",
	"dojo/_base/declare",
	"ibm/usmi/util/Utils",
	"./FinderBaseDataStore"
], function (djLang, declare, Utils, FinderBaseDataStore) {

	return declare("itme.finder.GroupDataStore", [ FinderBaseDataStore
	], {

		constructor : function (type, cache) {
			this.populateItems(cache);
		},
		populateItems : function () {
			this.inherited(arguments);
		},

		initiateTaskSearch : function (searchString, finderObj) {
			var query = "name:'*" + searchString + "*' OR category:'*" + searchString + "*'";
			Utils.CMTraceTimeDelta("finderTimer", "before initiating search", true);
			if (this._dataStore) {
				this._dataStore.fetch({
					query : {
						complexQuery : query
					},
					queryOptions : {
						ignoreCase : true
					},
					onError : djLang.hitch(finderObj, finderObj.fetchFailed),
					onComplete : djLang.hitch(finderObj, finderObj.doGroupSearch)
				});
			} else {
				finderObj.doGroupSearch(new Array(0), null);
			}
		},
		destroy : function () {
			this.inherited(arguments);
		}
	});
});
