/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
// Finder TaskCategory
define("ibm/usmi/widgets/finder/TaskCategory", [ "dojo/_base/declare"
], function (declare) {

	return declare("itme.finder.TaskCategory", null, {

		// private members       
		_category : null,
		_ids : null,
		_names : null,
		_icons : null,
		_selectedIndexes : null,
		_currentArrayIndex : 0,
		_currentSelectedIndex : 0,

		constructor : function (category) {
			this._category = category;
			this._ids = [];
			this._names = [];
			this._selectedIndexes = [];
			this._icons = [];
		},
		add : function (id, name, icon) {
			this._ids[this._currentArrayIndex] = id;
			this._names[this._currentArrayIndex] = name;
			this._icons[this._currentArrayIndex] = icon;
			this._currentArrayIndex = this._currentArrayIndex + 1;
			return this._currentArrayIndex - 1;
		},
		getCategory : function () {
			return this._category;
		},
		clearSelection : function () {
			this._selectedIndexes = null;
			this._currentSelectedIndex = 0;
			this._selectedIndexes = [];
		},
		addSelected : function (index) {
			this._selectedIndexes[this._currentSelectedIndex] = index;
			this._currentSelectedIndex = this._currentSelectedIndex + 1;
		},
		getSelectedCount : function () {
			return this._currentSelectedIndex;
		},
		getSelectedName : function (index) {
			return this._names[this._selectedIndexes[index]];
		},
		getSelectedIcon : function (index) {
			return this._icons[this._selectedIndexes[index]];
		},
		getSelectedId : function (index) {
			return this._ids[this._selectedIndexes[index]];
		},
		getIds : function () {
			return this._ids;
		},
		destroy : function () {
			this._ids.length = 0;
			this._names.length = 0;
			this._selectedIndexes.length = 0;
			this._icons.length = 0;
		}
	});
});