/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/widgets/table/DefaultItemsTableViewPersist", [
	"dojo/_base/declare",
	"dojo/_base/array",
	"dojo/_base/lang",
	"dojo/_base/json",
	"dojo/_base/unload",
	"dojo/cookie",
	"ibm/usmi/core/utils/Logger",
	"gridx/modules/Persist",
	"ibm/usmi/core/utils/_UsmiBrowserPersistence"
], function (declare, array, lang, json, unload, cookie, Logger, Persist, _UsmiBrowserPersistence) {

	return declare([
		Persist,
		_UsmiBrowserPersistence
	], {

		put : function (key, value, options) {
			var newkey = key + this.model.store.declaredClass;
			// only persist if there are columns in the table...  helps avoids empty table persistence
			if (value && value.column && value.column.length > 0) {
				this.setGlobalData(newkey, value);
			}
		},

		get : function (key) {
			var newkey = key + this.model.store.declaredClass;
			return this.getGlobalData(newkey);
		},
		
		//For column state restore---------------------
		_restoreColumnState: function(){
			var t = this,
				grid = t.grid,
				col, cols = [],
				found=false,
				columns = t.registerAndLoad('column', t._columnStateSaver, t);
			if(!lang.isArray(columns)){
					return;
			}
			
			//1. we do not change the order of the columns as current structure, columns chooser can sort the order
			//2. we need to set the col width via the width in persist storage
			cols=array.map(this.grid._columns, function(colInGrid){
				col=colInGrid;
				array.some(columns, function(colInPersist){
					if(colInPersist.id === col.id){
						col.declaredWidth=col.width = colInPersist.width;
						return true;
					}
				});
				return col;
			});
	
			grid.setColumns(cols);
		}

	});
});