/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
define("ibm/usmi/widgets/util/DefaultMenuProviderHelper", ["dojo/_base/kernel",
        "dojo/_base/declare",
        "dojo/topic",
        // TWL imports
        "ibm/tivoli/tip/navwidget/topology/dijit/MenuProviderHelper",
        "ibm/tivoli/tip/navwidget/topology/dijit/MenuProviderHelperBase",
        "ibm/usmi/util/DefaultMessageHandler",
        "ibm/tivoli/navmodel/Dataset"],
    function (dojo, declare, topic,
            MenuProviderHelper, MenuProviderHelperBase, DefaultMessageHandler, Dataset) {

    return declare([MenuProviderHelper], {

        getMenuItems: function(/*Object*/ context) {
            // summary:
            //        Coming soon
            // description:
            //        Coming soon
            // context:
            //        Coming soon

            // Turn off properties menu item by saying selection does not support properties.
            // We probably could have just not inherited from MenuProviderHelper since that class
            // just sets up the properties menu item, but this seems safer in case TWL decides
            // to add to MenuProviderHelper in the future.
            var selectedObjects = context.selection;
            var showPropertiesInContextMenu = context.showPropertiesInContextMenu;

            if(( selectedObjects.getItemCount() + selectedObjects.getLinkCount() + selectedObjects.getRelationshipCount()) == 1){

                if(selectedObjects.getItemCount() == 1){

                    var object = selectedObjects.getItems()[0];
                    if(showPropertiesInContextMenu===true){
                    	 object.setSupportsProperties(true);
                    } else {
                    	object.setSupportsProperties(false);
                    }
                   
                }
            }

            var items = this.inherited(arguments);

            return items;
        },

        getMenuCommand: function(/*Object*/ commandName, /*Object*/ context, /*Object*/ menuItem) {
            // summary:
            //        Coming soon
            // description:
            //        Coming soon
            // commandName:
            //        Coming soon
            // context:
            //        Coming soon
            // menuItem:
            //        Coming soon
            var result = null, generalTab;

            // Note: add code here to check the commandName (which is also the actionID from
            // menuItem) and if it is one of our actions, do or call whatever is needed to do
            // the work and then set the result to a no-op command so the TIPContextMenu will
            // take no action on the returned result
            // Ex:
            //     result = {"launchType":"NOOP"};
            //  or
            //     result = menuItem;  (if the launchType="NOOP" was already an attribute in the menu item)
            //

            //command name is = to actionID...so if one of the special menu items added above, do special processing

            // make sure we have a menu item (default action/task processing can call with just a
            // command and no menuItem)
            if (menuItem && menuItem.launchType === "JavaScript") {
                launchParms = dojo.fromJson(menuItem.uri);
                if (launchParms.topic) {
                    topic.publish(launchParms.topic, launchParms, menuItem, context);
                    result = {"launchType":"NOOP"};
                }
                else {
                    alert("topic not defined in launch parms from server task");
                    // TODO put up error message or log error indicating task did not specify correct launch parms
                }
                return result;
            } //else if (menuItem && menuItem.launchType == "WEB_URL") {
    //            this.launchURL (menuItem);
    //        }
            else {
                // Note: If this is NOT one of our client-side actions, DO NOT set result and let
                // the parent class command be returned
                result = (result) ? result : this.inherited(arguments);
                switch (commandName) {
    				case "nwmi_PropertiesNotebookDialog":
    					if(!this._propDialog){
    						break;
    					}
    					if(!this._propDialog._propNotebook){
    						break;
    					}
    					generalTab=this._propDialog._propNotebook.getPluggableView('GENERAL_PROPERTIES_VIEW');
    					if(!generalTab){
    						break;
    					}
    					if(!generalTab._propertyRendererObj){
    						break;
    					}
    					if(context.daHelper){
    						generalTab._propertyRendererObj._daHelper=context.daHelper;
    					}
    					
                }
                return result;
            }
        },

           launchURL: function(data)
           {
               console.log ("enter launchURL id ");

               var left   = (screen.width  )/2,
                   top    = (screen.height)/2,
                   params = 'top='+top+', left='+left;

               if(data.browserwindowid !== null) {
                   window.open(data.uri,data.browserwindowid, params);
               }
               else {
                   window.open(data.uri,"_self", params);
               }
           }
    });
});
