/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */

define(
		"ibm/usmi/widgets/util/ResourceMenuProviderHelper",
		[
			"dojo/_base/kernel",
			"dojo/_base/declare",
			"dojo/topic",
			"dojo/i18n!./nls/ResourceMenuProvider",
			// TWL imports
			"ibm/tivoli/tip/navwidget/topology/dijit/MenuProviderHelper",
			"ibm/tivoli/tip/navwidget/topology/dijit/MenuProviderHelperBase",
			"ibm/usmi/widgets/util/DefaultMenuProviderHelper",
			"ibm/tivoli/tip/navwidget/dijit/DefaultMessageHandler",
			"ibm/tivoli/navmodel/Dataset"
		],
		function (dojo, declare, topic, mri, MenuProviderHelper, MenuProviderHelperBase, DefaultMenuProviderHelper,
				DefaultMessageHandler, Dataset) {

			return declare(
					[ DefaultMenuProviderHelper
					],
					{
						nls : mri,

						getMenuItems : function (/* Object */context) {
							// summary:
							// Coming soon
							// description:
							// Coming soon
							// context:
							// Coming soon
							var items = this.inherited(arguments);
							var selectedObjects = context.selection;
							if ((selectedObjects.getItemCount() + selectedObjects.getLinkCount() + selectedObjects
									.getRelationshipCount()) == 1) {

								var object = null;

								if (selectedObjects.getItemCount() == 1) {
									object = selectedObjects.getItems()[0];
								} else if (selectedObjects.getRelationshipCount() == 1) {
									object = selectedObjects.getRelationships()[0];
								} else if (selectedObjects.getLinkCount() == 1) {
									object = selectedObjects.getLinks()[0];
								} else {
									console.log("Cannot handle non link, rel, or item objects. No action preformed.");
								}

								// if the object doesnt support properties, dont
								// add prop menu item.
								if (object && object.supportsProperties()) {
									// Add the PropertiesNotebook to the Menu
									// list of items
									items
											.push({
												"actionID" : "nwmi_PropertiesNotebookDialogISC",

												"label" : ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil
														.getStringWithEllipsis(this.nls.LEGACY_PROPERTIES),
												"launchType" : "WEB_URL",
												"uri" : window.location.protocol
														+ '//'
														+ window.location.hostname
														+ ':'
														+ window.location.port
														+ '/ibm/action/launch?pageID=com.ibm.usmi.console.resnav.navigationElement&root='
														+ object.getId()
														+ '&hideTaskArea=false&disableNavArea=false&hideBannerArea=false&hideTaskBarArea=false&hint=PROPERTIES'
											});
								}

							}

							return items;
						}
					});
		});